'From etoys3.0 of 24 February 2008 [Letztes Update: #1985] on 9 May 2008 at 4:47:26 pm'!
"Change Set:		BlockAttack
Date:			10 March 2008

Authors: David Jaeger, Marco Krueger, Mark Oelze, Max Plauth, Nico Rehwaldt, David Schwalb, and Arian Treffer
Prepared for XO by: Robert Krahn

Hasso-Plattner-Institut
Software Architecture Group
http://www.swa.hpi.uni-potsdam.de/"!

Object subclass: #BAAbstractPlayer
	instanceVariableNames: 'cursor actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Players'!

!BAAbstractPlayer commentStamp: 'AT 7/5/2007 15:51' prior: 0!
I provide the possibilites to control a TACursor. Subclasses have to define the behavior.!

Object subclass: #BAColumn
	instanceVariableNames: 'index ground playground'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAColumn commentStamp: 'AT 2/21/2008 19:56' prior: 0!
I represent a Column of Boxes on the BAPlayGround.!

BAAbstractPlayer subclass: #BADoNothingPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Players'!

!BADoNothingPlayer commentStamp: 'AT 7/5/2007 15:52' prior: 0!
I am a fully working player. However, I do nothing.!

BAAbstractPlayer subclass: #BAHumanPlayer
	instanceVariableNames: 'keyboardDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Players'!

!BAHumanPlayer commentStamp: 'AT 7/5/2007 15:53' prior: 0!
I am a player reacting to keyboard input.!

ImageMorph subclass: #BAMorph
	instanceVariableNames: 'imageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAMorph commentStamp: 'AT 6/5/2007 13:01' prior: 0!
Superclass for all visible objects of TAttack.
Provides functionality for loading images from the project image repository.!

BAMorph subclass: #BAAbstractDialog
	instanceVariableNames: 'parentMenu action icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Dialogs'!
BAMorph subclass: #BAAbstractPlayground
	instanceVariableNames: 'columns cursor statusDisplay score raisingDelay gameIsOver gameIsPaused gameplayer level nextLevel elapsedTime lastFramesTime lastFramesCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Playgrounds'!

!BAAbstractPlayground commentStamp: 'AT 6/21/2007 20:03' prior: 0!
I am the field in which the game is played. I provide all methods for a working game. However, some rules have to be defined by subclasses.!

BAAbstractPlayground subclass: #BADefaultPlayground
	instanceVariableNames: 'difficulty bigBlocks bigBlockDelay colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Playgrounds'!

!BADefaultPlayground commentStamp: 'AT 6/21/2007 20:14' prior: 0!
I define the rules for an endless game. It stops only if the blocks reach my top.!

BAMorph subclass: #BAGridMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAGridMorph commentStamp: 'AT 5/31/2007 10:08' prior: 0!
Superclass for all objects moved in the playground.!

BAGridMorph subclass: #BAAbstractBlock
	instanceVariableNames: 'gap topBlock bottomBlock isMarked isActive hasMoved chain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BAAbstractBlock commentStamp: 'AT 6/14/2007 21:46' prior: 0!
Superclass for all objects representing a block.!

BAAbstractBlock subclass: #BABlock
	instanceVariableNames: 'fallingDelay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BABlock commentStamp: 'AT 5/31/2007 10:11' prior: 0!
Superclass for all blocks.!

BABlock subclass: #BAColoredBlock
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BAColoredBlock commentStamp: 'NR 6/4/2007 17:51' prior: 0!
Class for all normal behaving colored blocks.
!

BAGridMorph subclass: #BACursor
	instanceVariableNames: 'xPos yPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BACursor commentStamp: 'NR 6/4/2007 18:36' prior: 0!
I am an element movable by the user to change stones and so on.!

BABlock subclass: #BADeadBlock
	instanceVariableNames: 'delay score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BADeadBlock commentStamp: 'AT 7/19/2007 20:35' prior: 0!
I am a dead block, disappearing after a short time!

BAAbstractBlock subclass: #BAEmptyBlock
	instanceVariableNames: 'column row'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BAEmptyBlock commentStamp: 'AT 6/21/2007 00:14' prior: 0!
I am a Null Block representing that no block was found.!

BAEmptyBlock subclass: #BABlockedBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BABlockedBlock commentStamp: 'AT 6/21/2007 00:14' prior: 0!
I am a Null Block representing that the desired position is blocked.!

BAAbstractDialog subclass: #BAHelpDialog
	instanceVariableNames: 'pageNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Dialogs'!
BAAbstractDialog subclass: #BAKeyDialog
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Dialogs'!
BAMorph subclass: #BAMenu
	instanceVariableNames: 'activeMenu parentMenu leftBorder rightBorder entries selection leftIndex keyboardDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAMenu commentStamp: 'NR 7/6/2007 16:35' prior: 0!
I am used for navigation in the TetrisAttack game.!

BAMorph subclass: #BAMenuEntry
	instanceVariableNames: 'name icon action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAMenuEntry commentStamp: 'NR 7/6/2007 16:35' prior: 0!
I am part of the Menu.!

BAAbstractDialog subclass: #BAPasswordDialog
	instanceVariableNames: 'password keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Dialogs'!
Object subclass: #BAPuzzleLevel
	instanceVariableNames: 'id count password columns passwordHash score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAPuzzleLevel commentStamp: 'AT 7/20/2007 01:23' prior: 0!
I represent a PuzzleLevel, which can be loaded by a TAPuzzelPlayground.!

BAAbstractPlayground subclass: #BAPuzzlePlayground
	instanceVariableNames: 'swapCount puzzleLevel history blockMoved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Playgrounds'!

!BAPuzzlePlayground commentStamp: 'AT 7/5/2007 15:54' prior: 0!
I define rules for a puzzle game. There are no new lines appearing, but the playground has to be cleared with a limited amount of swap actions.!

BAAbstractPlayground subclass: #BASimulationPlayground
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Playgrounds'!

!BASimulationPlayground commentStamp: 'AT 7/19/2007 21:20' prior: 0!
I am a playground showing a simulation of the game. I assure that blocks never reach the top, ignore any game over or pause signals, and provide the possibility to execute code each step.

I am used as background animation when the program was just started and for testing purpose (TetrisAttack simulationBigBlocks).!

BAMorph subclass: #BAStatusDisplay
	instanceVariableNames: 'fields rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BAStatusDisplay commentStamp: 'NR 6/14/2007 21:42' prior: 0!
I show scores and other information.!

BABlock subclass: #BASynchronizedBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BASynchronizedBlock commentStamp: 'AT 7/20/2007 01:22' prior: 0!
I am synchronizing my behavior with other blocks.!

BASynchronizedBlock subclass: #BASlaveBlock
	instanceVariableNames: 'master'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BASlaveBlock commentStamp: 'AT 7/1/2007 21:41' prior: 0!
I am a slave of TATrashBlock.!

BASynchronizedBlock subclass: #BATrashBlock
	instanceVariableNames: 'slaves size isSynchronized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack-Blocks'!

!BATrashBlock commentStamp: 'AT 6/21/2007 00:14' prior: 0!
I am the master of a bunch of blocks, looking like one big block.!

BAMorph subclass: #BlockAttack
	instanceVariableNames: 'skin menu playgrounds activeComponents lastStep width bodyparts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-BAttack'!

!BlockAttack commentStamp: 'NR 6/15/2007 19:38' prior: 0!
I am the main window that holds everything.!


!BAAbstractPlayer methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:36'!
action: aSymbol

	^ actions at: aSymbol ifAbsent: [[]]! !

!BAAbstractPlayer methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:20'!
cursor

	^ cursor! !

!BAAbstractPlayer methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:20'!
cursor: aTACursor

	cursor := aTACursor.! !

!BAAbstractPlayer methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:36'!
doAction: aSymbol
	"Execute the command, if not possible do nothing"

	cursor ifNotNil: [(self action: aSymbol) value].! !

!BAAbstractPlayer methodsFor: 'initialization' stamp: 'AT 7/3/2007 23:20'!
initialize

	super initialize.	
	self initializeActions.
	cursor := nil.! !

!BAAbstractPlayer methodsFor: 'initialization' stamp: 'AT 7/1/2007 23:23'!
initializeActions

	(actions := Dictionary new)
		at: #up put: [self cursor moveUp];
		at: #down put: [self cursor moveDown];
		at: #left put: [self cursor moveLeft];
		at: #right put: [self cursor moveRight];
		at: #swap put: [self cursor swapBlocks];
		at: #nextLine put: [self cursor nextLine].! !

!BAAbstractPlayer methodsFor: 'dispatching' stamp: 'NR 7/10/2007 20:07'!
keyEvent: anEvent
	"Handle incomming keyEvent"! !


!BAColumn methodsFor: 'block control' stamp: 'AT 2/21/2008 19:56'!
blockAtHeight: aFloat
	"Answer Block at the height (+/- tolerance) or 
	a new instance of BAEmptyBlock if no block was found or 
	a new instance of BABlockedBlock if the position is blocked"

	| block |
	block := self firstActive blockAtHeight: aFloat-1.
	block isEmpty ifTrue: [block gridPosition: index@aFloat].
	^ block! !

!BAColumn methodsFor: 'block control' stamp: 'AT 7/6/2007 00:44'!
blocksDo: aBlock

	self first blocksDo: aBlock.! !

!BAColumn methodsFor: 'block control' stamp: 'AT 7/6/2007 00:49'!
blockUnder: aFloat
	"Answer a block object with its top < aFloat"

	^ self firstActive blockUnder: aFloat - 1! !

!BAColumn methodsFor: 'block control' stamp: 'AT 7/9/2007 23:24'!
clear
	"Remove all blocks in this column"
	
	self blocksDo: [ :block | block remove].
	! !

!BAColumn methodsFor: 'block control' stamp: 'AT 7/6/2007 00:50'!
firstActive
	"Answer starting block for block finding algorithms"
	
	^ self first isActive 
		ifTrue: [self first] 
		ifFalse: [self first topBlock]! !

!BAColumn methodsFor: 'block control' stamp: 'AT 2/21/2008 19:57'!
insertAtBottom: aBABlock
	"Insert the block at the bottom of the column"

	^ self insertBlock: aBABlock atHeight: 0! !

!BAColumn methodsFor: 'block control' stamp: 'AT 2/21/2008 19:57'!
insertAtTop: aBABlock
	"Insert the block at the top of the column"
	
	^ self 
		insertBlock: aBABlock activate
		atHeight: self highestRow + aBABlock size! !

!BAColumn methodsFor: 'block control' stamp: 'AT 2/21/2008 19:57'!
insertBlock: aBABlock atHeight: aFloat
	"Insert the block into the column"
		
	| bottom |
	bottom := self blockUnder: aFloat.
	^ aBABlock 
		insertAbove: bottom 
		gap: (aFloat - bottom row - aBABlock size).		
! !

!BAColumn methodsFor: 'block control' stamp: 'AT 2/21/2008 19:58'!
nextLine: aBABlock
	"Activate the lowest block and add 
	the given block as new line"
	
	(self first isActive) ifFalse: [self first activate].
	self insertAtBottom: aBABlock.
	^ aBABlock addToPlayground: self playground.
	
! !

!BAColumn methodsFor: 'accessing' stamp: 'mk 6/20/2007 21:28'!
column
	"Answer the number of this column"

	^ index! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/5/2007 20:47'!
first

	^ ground topBlock! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 6/26/2007 22:49'!
height
	"Answer the absolute height"
	
	^ self highestRow + self yOffset.
	! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:36'!
highestRow

	^ self firstActive highestRow! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:37'!
index
	
	^ index! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 2/21/2008 19:46'!
index: anInteger
	"Create the trunk for a column of blocks."
	
	index := anInteger.
	ground := BAEmptyBlock createAt: index@0.
	(BAEmptyBlock createAt: index@(self maxRow+1)) 
		connectWith: ground.! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:48'!
maxRow
	"Answer the height when the highest block 
	touches	the top of the playground"
	
	^ playground maxRow! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:40'!
playground

	^ playground! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:40'!
playground: aTAPlayground

	playground := aTAPlayground! !

!BAColumn methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:49'!
yOffset
	"Answer the offset of the first active row 
	to the bottom of the playground"
	
	(self first isActive) ifTrue: [^ 0].
	^ self first gap + self first size.! !

!BAColumn methodsFor: 'zOld' stamp: 'AT 7/6/2007 00:32'!
getBlockAtHeight: anInt
	"Old block finding algorithm, only as backup"
	
	
	"Answer Block at the height (+/- 0.25) or 
	a new instance of TAEmptyBlock if no block was found or 
	a new instance of TABlockedBlock if the position is blocked"
	
	"
	| block y |
	block := self getGround.
	y := anInt.
	
	[block := block topBlock.
	 y := y - (block gap + block size)] 
		doWhileFalse: [
			(y < block size) or: 
			[block isEmpty] or: 
			[block topBlock isEmpty]].
	
	(y abs < (block size - 0.75)) ifTrue: [^ block]
		ifFalse: [
			(y abs < block size) ifTrue: [
				^ TABlockedBlock createAt: index@anInt]].
	^ TAEmptyBlock createAt: index@anInt"! !

!BAColumn methodsFor: 'zOld' stamp: 'AT 7/6/2007 00:32'!
getBlockUnder: aFloat
	"Old block finding algorithm, only as backup"
	
	
	"Answer a block object, beeing at the height or under it"
	"
	| block y |
	block := self getGround.
	y := aFloat.
	
	[(y < (block topBlock size + block topBlock gap)) or: 
		[block topBlock isEmpty]] 
			whileFalse: [
				block := block topBlock.
		 		y := y - (block size + block gap)].
	^ block "! !

!BAColumn methodsFor: 'zOld' stamp: 'AT 7/6/2007 00:32'!
getGround
	"Old block finding algorithm, only as backup"
	
	
	"Answer starting block for getBlock algorithms"
	"
	^ self first topBlock isActive 
		ifTrue: [self first] 
		ifFalse: [self first topBlock]"! !

!BAColumn methodsFor: 'zOld' stamp: 'AT 7/6/2007 00:34'!
swapWith: aCol atHeight: anInt
	"Not in use anymore, see TAAbstractPlayground>>swapRightAt:"

	"Swap blocks at the height with the given column"
	
	"
	| block1 block2 |
	block1 := self blockAtHeight: anInt.
	block2 := aCol blockAtHeight: anInt.
	block1 ifNotBlocked: [ 
		block2 ifNotBlocked: [ 	"
			"swap only if no block is blocking"
			"| row1 |
			row1 := block1 row.			 
			block1 moveToColumn: aCol Row: block2 row.
			block2 moveToColumn: self Row: row1.
		] .
	]."! !


!BAColumn class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 00:52'!
create
	
	^ self new! !


!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:35'!
actionAtKey: aKeyValue

	^ self keyboardDictionary at: aKeyValue ifAbsent: nil! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'NR 6/21/2007 14:00'!
addKeys: aKeyArray forAction: aSymbol
	
	aKeyArray do: [:key | 
		self keyboardDictionary add: key -> aSymbol].! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:21'!
clearKeys
	
	self keyboardDictionary 
		ifNotNil: [self keyboardDictionary: Dictionary new].! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:21'!
keyboardDictionary

	^ keyboardDictionary! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:21'!
keyboardDictionary: anIdentityDictionary

	keyboardDictionary := anIdentityDictionary.! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:32'!
removeKey: aKeyValue
	
	self keyboardDictionary 
		ifNotNil: [self keyboardDictionary removeKey: aKeyValue].! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 7/3/2007 23:28'!
setFromArray: anArray
	
	| newActions |
	newActions := {#up. #down. #left. #right. #swap. #nextLine}.
	1 to: 6 do: [ :i |
		self addKeys:(anArray at: i) forAction: (newActions at: i)].
! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 2/21/2008 19:36'!
setPlayer1Initialization
	
	self setFromArray: BlockAttack player1Keys.
	
! !

!BAHumanPlayer methodsFor: 'keyboard accessing' stamp: 'AT 2/21/2008 19:36'!
setPlayer2Initialization
	
	self setFromArray: BlockAttack player2Keys.! !

!BAHumanPlayer methodsFor: 'initialization' stamp: 'AT 7/3/2007 23:29'!
initialize
	
	super initialize.
	keyboardDictionary := Dictionary new.! !

!BAHumanPlayer methodsFor: 'dispatching' stamp: 'NR 7/10/2007 20:07'!
keyEvent: anEvent

	self doAction: (self actionAtKey: anEvent keyValue).! !


!BAMorph methodsFor: 'submorphs-add/remove' stamp: 'AT 7/6/2007 01:29'!
addMorphCentered: aMorph	
	
	self addMorph: aMorph.
	aMorph moveToCenter.! !

!BAMorph methodsFor: 'submorphs-add/remove' stamp: 'AT 7/6/2007 01:30'!
addMorphRelative: aMorph	
	
	aMorph position: aMorph position + self position.
	self addMorph: aMorph.! !

!BAMorph methodsFor: 'skin support' stamp: 'AT 7/6/2007 01:27'!
imageName
	"Answers the imageName which is currently loaded as the
	recievers 'background image'. It does not contain any 
	skin information."
	
	^ imageName
	! !

!BAMorph methodsFor: 'skin support' stamp: 'NR 6/26/2007 00:19'!
imageName: aName
	
	imageName := aName.	
	self updateSkin.! !

!BAMorph methodsFor: 'skin support' stamp: 'AT 7/1/2007 19:35'!
noteNewOwner: aMorph

	super noteNewOwner: aMorph.
	self updateSkin.! !

!BAMorph methodsFor: 'skin support' stamp: 'AT 2/21/2008 19:35'!
skin

	^ owner 
		ifNil: [BlockAttack defaultSkin] 
		ifNotNil: [owner skin]
	! !

!BAMorph methodsFor: 'skin support' stamp: 'AT 2/21/2008 19:35'!
updateSkin

	self 
		image: (BlockAttack 
				imageForm: self imageName 
				fromSkin: self skin);
		submorphsDo: [:morph | morph updateSkin].! !

!BAMorph methodsFor: 'initialization' stamp: 'rkrk 5/9/2008 16:40'!
initialize

	super initialize.
	
	imageName := 'misc' , FileDirectory slash , 'empty'.
	! !

!BAMorph methodsFor: 'geometry' stamp: 'AT 7/3/2007 15:17'!
moveToCenter

	owner ifNotNil: [
		self positionRelative: (owner extent - self extent) * 0.5]! !

!BAMorph methodsFor: 'geometry' stamp: 'AT 7/3/2007 15:17'!
positionRelative: aPoint

	self position: (owner position + aPoint)! !

!BAMorph methodsFor: 'geometry' stamp: 'AT 7/2/2007 23:59'!
replaceWith: aTAMorph

	owner ifNotNil: [
		owner replaceSubmorph: self by: aTAMorph]! !

!BAMorph methodsFor: 'stepping' stamp: 'AT 7/3/2007 15:19'!
step: seconds! !

!BAMorph methodsFor: 'stepping' stamp: 'AT 6/14/2007 23:43'!
subStep: seconds
	"Make all submorphs step, then step too"
	
	self submorphsDo: [ :morph | morph subStep: seconds].
	self step: seconds.! !


!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:24'!
action: aBlock

	action := aBlock! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:24'!
activeMenu

	^ self! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:28'!
close

	parentMenu ifNotNil: [parentMenu closeSubmenu].
	^ icon! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:25'!
closeSubmenu
	"Do nothing, this is just part of the menu interface"! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:25'!
nextIcon

	^ self subclassResponsibility ! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:24'!
parentMenu: aTAMenu

	parentMenu := aTAMenu! !

!BAAbstractDialog methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:24'!
updateSkin

	super updateSkin.
	icon moveToCenter.! !

!BAAbstractDialog methodsFor: 'initialization' stamp: 'AT 7/20/2007 01:24'!
initialize

	super initialize.
	icon := self nextIcon.
	self addMorphCentered: icon.! !

!BAAbstractDialog methodsFor: 'event handling' stamp: 'AT 7/20/2007 01:28'!
keyEvent: anEvent

	icon replaceWith: (icon := self nextIcon)! !


!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:45'!
addBlock: aBlock

	self addMorph: aBlock behind: cursor.! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'NR 7/12/2007 22:20'!
addNewLine
	"Add a new line of blocks at the bottom of the reciever"	

	| block left top |
	left := nil.
	columns do: [:column |		
		top := column first type. 
		block := self nextRandomBlockBut: {left. top}.
		left := (column nextLine: block) type].
	cursor newLineNotification.
	self delayRaising: 0. 


	! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/6/2007 13:04'!
addTrashBlock: aPoint
	"Notify the reciever that a trash block of the given size 
	ought to be added"! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:48'!
allBlocksDo: aBlock

	columns do: [:column |
		column blocksDo: [ :block |
			block isEmpty ifFalse: [aBlock value: block]]]! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:48'!
checkGameOver

	^ self subclassResponsibility.

! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/6/2007 01:13'!
difficulty: aSymbol! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:48'!
fallingSpeed

	^ self subclassResponsibility! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:48'!
gameOver

	gameIsOver  := true.
	self pause.! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'ds 7/9/2007 21:59'!
levelUp

	self level: level + 1.
	nextLevel := nextLevel + (1000 * self speedFactor).! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/9/2007 11:06'!
nextLine
	"Notify the reciever that a new line is wanted. 
	Called by the cursor"
	
	self currentHeight < (self maxRow - 1.25)
		ifTrue: [self addNewLine]! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/5/2007 16:30'!
nextRandomBlockBut: aCollection
	"Create a new random block"	

	^ self subclassResponsibility.


	! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:49'!
pause

	self isPaused: true.! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:49'!
raisingSpeed

	^ self subclassResponsibility! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:49'!
run

	self isPaused: false.! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:49'!
setLevel: anInteger

	nextLevel := 0.
	level := anInteger - 1.
	self levelUp.! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:49'!
speedFactor

	^ self subclassResponsibility! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/20/2007 00:56'!
swapRightAt: aPoint
	"Swap the block at aPoint with its right neighbor"
	
	| block1 block2 |
	block1 := self block: aPoint.
	block1 ifNotBlocked: [ 
		block2 := self block: aPoint + (1@0).
		block2 ifNotBlocked: [
			self swap: block1 with: block2]].

	! !

!BAAbstractPlayground methodsFor: 'game control' stamp: 'AT 7/20/2007 00:58'!
swap: block1 with: block2
	
	| p1 p2 |
	p1 := block1 gridPosition.
	p2 := block2 gridPosition.
	block1 leaveColumn.
	block2 leaveColumn.
	block1 insertAt: p2.
	block2 insertAt: p1.
	! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'ds 7/9/2007 21:04'!
addToScore: anInteger
	"Add anInteger to the current score"

	score := score + anInteger.
	self updateScoreDisplay: score.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 2/21/2008 19:44'!
block: aPoint

	^ (columns 
		at: aPoint x 
		ifAbsent: [^ BABlockedBlock createAt: aPoint])
			blockAtHeight: aPoint y.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:39'!
clear
	
	columns do: [:column | column clear].
	! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:39'!
clippingBounds

	^ self bounds expandBy: -2@-2! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:39'!
columns

	^ columns! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:39'!
column: anInt

	^ columns at: anInt! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 6/27/2007 00:43'!
currentHeight
	"Answer the height of the highest column"
	
	| result |
	result := 0.
	columns do: [ :column |
		result := result max: column height].
	^ result.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:39'!
cursor

	^ cursor
	! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:59'!
cursor: aTACursor

	cursor 
		ifNil: [self addMorph: aTACursor]
		ifNotNil: [cursor replaceWith: aTACursor].
	cursor := aTACursor.	
	self gameplayer ifNotNil: [self gameplayer cursor: cursor].		
	cursor updateWorldPosition.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/20/2007 02:07'!
delayRaising: aFloat

	raisingDelay := raisingDelay / 2 + aFloat! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:41'!
gameplayer

	^ gameplayer! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:41'!
gameplayer: aTAPlayer

	gameplayer := aTAPlayer.
	gameplayer cursor: self cursor.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:43'!
ifDoRaising: aBlock

	(raisingDelay > 0)
		ifFalse: [aBlock value].! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/20/2007 02:02'!
ifDoRaising: then else: else

	^ (raisingDelay > 0)
		ifTrue: [else value]
		ifFalse: [then value]! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
isPaused

	^ gameIsPaused! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
isPaused: aBool

	gameIsPaused := aBool or: [gameIsOver]! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
level

	^ level! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
level: anInteger

	level := anInteger.
	self updateLevelDisplay: level.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 6/29/2007 13:34'!
maxRow
	"Answer the height when the highest block touches the top of the playground"
	
	^ 11.3! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
resetScore

	score := 0.
	self updateScoreDisplay: score.! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
score

	^ score! !

!BAAbstractPlayground methodsFor: 'accessing' stamp: 'AT 7/2/2007 23:42'!
tetrisAttack

	^ owner owner.! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/6/2007 13:08'!
allMorphsUpdate

	self submorphsDo: [:morph | morph updateWorldPosition].! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/6/2007 13:08'!
checkNextLevel
	
	score >= nextLevel ifTrue: [self levelUp]! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/6/2007 13:09'!
markAndSweep	
	"Find all blocks forming a combination and remove them"
	
	"new marking algorithm"
	self allBlocksDo: [ :block |
		block hasMoved ifTrue: [block findMatches: 0]].
	self sweep.
	
	"old algorithm, marking rows and columns;
	not working anymore, as to many messages were changed;
	only left for documentation purpose"
	"| b1 b2 b3 |
	1 to: 9 do: [:row |
		b2 := self block: 1@row.
		b3 := self block: 2@row.
		3 to: 6 do: [:col |
			b1 := b2.
			b2 := b3.
			b3 := self block: col@row.
			b1 ifAccepts: b2 do: [
				b2 ifAccepts: b3 do: [		
					b3 ifAccepts: b1 do: [				
						b1 mark.
						b2 mark.
						b3 mark.]]]]].
	
	1 to: 6 do: [:col |
		b2 := self block: col@1.
		b3 := self block: col@2.
		3 to: 9 do: [:row |
			b1 := b2.
			b2 := b3.
			b3 := self block: col@row.
			b1 ifAccepts: b2 do: [
				b2 ifAccepts: b3 do: [
					b1 mark.
					b2 mark.
					b3 mark.]]]].
	
	self sweep."! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:47'!
step: seconds
		
	elapsedTime := elapsedTime + seconds.	
	self 
		updateDelays: seconds;
		checkNextLevel;
		markAndSweep;	
		allMorphsUpdate;		
		checkGameOver;
		updateFramesDisplay: seconds;
		updateElapsedTimeDisplay: elapsedTime.

	
! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:45'!
subStep: seconds
	"SubStep if game is running"

	gameIsPaused	ifFalse: [
			self submorphsDo: [ :morph | 
				morph subStep: seconds].
			self step: seconds].! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/18/2007 01:37'!
sweep
	"Sweep all blocks which are marked and check for 
	combo and chain bonus"

	| combo chain n |
	combo := 0.
	chain := 0.
	n := 0.
	self allBlocksDo: [:block|
		block ifMarked: [
			combo := combo + 1.
			chain := chain max: block chain]].
	self allBlocksDo: [ :block |
		block ifMarked: [
			n := n+1.
			block sweep: n of: combo]].
	self sweepedChains: chain andCombos: combo.! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 02:05'!
sweepedChains: chain andCombos: combo
	
	chain > 0
		ifTrue: [
			self delayRaising: chain*combo.
			self tetrisAttack notifyChainSize: chain*combo by: self.
			^ self addToScore: 10 * chain squared * combo squared].
	combo = 3 ifTrue: [
		^ self delayRaising: 1].
	combo > 3 ifTrue: [
		self delayRaising: combo / 2.
		self tetrisAttack notifyComboSize: combo by: self.
		self addToScore: 10 * combo squared].! !

!BAAbstractPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:47'!
updateDelays: seconds

	raisingDelay > 0 ifTrue: [
		raisingDelay := raisingDelay - seconds].! !

!BAAbstractPlayground methodsFor: 'grid' stamp: 'NR 6/28/2007 11:00'!
gridOffset

	^ (self gridXOffset)@(self gridYOffset)! !

!BAAbstractPlayground methodsFor: 'grid' stamp: 'AT 7/6/2007 13:06'!
gridScale
	"Answer pixels corresponding to 1 grid unit"

	^ 51! !

!BAAbstractPlayground methodsFor: 'grid' stamp: 'NR 6/28/2007 11:03'!
gridXOffset
	"Answer the relative xOffset of this grid"

	^ 8! !

!BAAbstractPlayground methodsFor: 'grid' stamp: 'AT 7/6/2007 12:59'!
gridYOffset
	"Answer the relative yOffset of the grid"

	^ (self height - 2) - ((self column: 1) yOffset * self gridScale)! !

!BAAbstractPlayground methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:34'!
initialize
	"Initialize TAPlayGround instance"
	
	super initialize.
	self 
		clipSubmorphs: true;
		initializeInstanceVars;
		initializeColumns;
		cursor: BACursor create;
		statusDisplay: BAStatusDisplay create;
		resetScore;
		addNewLine;
		setLevel: 1.! !

!BAAbstractPlayground methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:31'!
initializeColumns
	"Initialize 6 columns"
	
	columns := Array new: 6.
	1 to: 6 do: [:i |
		(columns at: i put: BAColumn create)
			playground: self;
			index: i].
! !

!BAAbstractPlayground methodsFor: 'initialization' stamp: 'AT 7/20/2007 01:50'!
initializeInstanceVars

	raisingDelay := 0.
	score := 0.
	gameIsPaused := false.
	gameIsOver := false.
	elapsedTime := 0.
	lastFramesTime := 0.
	lastFramesCount := 0.! !

!BAAbstractPlayground methodsFor: 'dispatching' stamp: 'NR 7/10/2007 20:03'!
keyEvent: anEvent
	
	self gameplayer keyEvent: anEvent.! !

!BAAbstractPlayground methodsFor: 'notifies' stamp: 'AT 7/19/2007 21:14'!
notifyBlockMoved! !

!BAAbstractPlayground methodsFor: 'notifies' stamp: 'AT 7/19/2007 21:16'!
notifyBlockSweepesAt: aPoint

	"Notify neighbors"
	{0@1. 1@0. 0@-1. -1@0} do: [ :p |
		(self block: aPoint - p)
			notifyNeighborSweepes: p].
	 ! !

!BAAbstractPlayground methodsFor: 'notifies' stamp: 'AT 7/19/2007 21:11'!
notifyLineAppeared
	"Notify the playground that a new line has 
	reached the surface"
	
	self addNewLine.! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/2/2007 23:56'!
statusDisplay

	^ statusDisplay! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/6/2007 13:08'!
statusDisplay: aTAStatusDisplay

	statusDisplay ifNotNil: [
		statusDisplay replaceWith: aTAStatusDisplay].
	statusDisplay := aTAStatusDisplay.
	self updateStatusDisplay.
! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/3/2007 00:01'!
updateBlocksWaitingDisplay: anInteger

	statusDisplay updateBlocksWaiting: anInteger.! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/6/2007 10:19'!
updateElapsedTimeDisplay: seconds

	statusDisplay updateTime: seconds.! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'ds 7/9/2007 20:38'!
updateFramesDisplay: aFloat
	"aFloat is the duration of the last frame,
	which should be bigger than zero."
	
	lastFramesTime := lastFramesTime + aFloat. 
	lastFramesCount := lastFramesCount + 1.
	
	(lastFramesTime > 1  ) ifTrue: [
		statusDisplay updateFrames: (lastFramesCount/lastFramesTime). 
		lastFramesTime := 0.
		lastFramesCount := 0].! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/3/2007 00:01'!
updateLevelDisplay: anInteger

	statusDisplay updateLevel: anInteger.! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/3/2007 00:01'!
updateScoreDisplay: anInteger

	statusDisplay updateScore: anInteger.! !

!BAAbstractPlayground methodsFor: 'status display' stamp: 'AT 7/3/2007 00:03'!
updateStatusDisplay

	self 
		updateScoreDisplay: score;
		updateLevelDisplay: level;
		updateFramesDisplay: 0;
		updateElapsedTimeDisplay: elapsedTime.
	! !


!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 7/2/2007 23:13'!
addTrashBlock: aPoint
	bigBlocks addFirst: aPoint.! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:45'!
difficulty: aSymbol

	difficulty := aSymbol.
	colors := BAColoredBlock blockTypesIn: aSymbol.
	
	(aSymbol = #normal) ifTrue: [^ self setLevel: 10].
	(aSymbol = #hard) ifTrue: [^ self setLevel: 20].
	self setLevel: 1! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 7/13/2007 15:24'!
fallingSpeed

	^ 5.0! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:32'!
gameOver

	super gameOver.
	self tetrisAttack
		menu: BAMenu createMainMenu;
		showMenu.! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:45'!
nextRandomBlockBut: aCollection
	"Create a new random block"	
		
	^ BAColoredBlock randomTypeOf: colors but: aCollection.
! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 7/20/2007 02:02'!
raisingSpeed

	^ self ifDoRaising: [0.1 * self speedFactor] else: [0].! !

!BADefaultPlayground methodsFor: 'game control' stamp: 'AT 7/13/2007 15:24'!
speedFactor

	^ (1 + (level/12))! !

!BADefaultPlayground methodsFor: 'stepping' stamp: 'AT 2/21/2008 19:47'!
checkBigBlocks
	"Create big blocks if necessary"

	((bigBlocks size > 0) and: 
		[bigBlockDelay<= 0]) ifTrue: [
			| size |
			size := bigBlocks first.
			self currentHeight > (self maxRow - size y - 1)
				ifTrue: [^ bigBlockDelay := 0.5].
			BATrashBlock createSize: size in: self.
			bigBlocks := bigBlocks allButFirst.
			bigBlockDelay := 1.5]! !

!BADefaultPlayground methodsFor: 'stepping' stamp: 'AT 7/3/2007 00:19'!
checkGameOver

	self currentHeight > self maxRow 
		ifTrue: [self tetrisAttack notifyGameOver].! !

!BADefaultPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:48'!
step: seconds

	super step: seconds.
	self checkBigBlocks;
		updateBlocksWaitingDisplay: bigBlocks size.! !

!BADefaultPlayground methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:48'!
updateDelays: seconds

	super updateDelays: seconds.
	bigBlockDelay > 0 ifTrue: [
		bigBlockDelay := bigBlockDelay - seconds].! !

!BADefaultPlayground methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:45'!
initialize

	colors := BAColoredBlock blockTypesIn: #easy.
	super initialize.
	self statusDisplay: BAStatusDisplay createForDefaultGame.
	bigBlocks := RunArray new.
	bigBlockDelay := 0.
	colors := BAColoredBlock blockTypes.! !


!BAGridMorph methodsFor: 'accessing' stamp: 'AT 7/3/2007 09:58'!
anchorPoint
	"Answer the anchor point of the morphs image in pixels"
	
	^ 0@0! !

!BAGridMorph methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:54'!
column
	"Answer the number of the recievers column"

	^ self subclassResponsibility! !

!BAGridMorph methodsFor: 'accessing' stamp: 'AT 7/3/2007 09:58'!
gridPosition
	"Answer the relative position in the grid"
	
	^ self column @ self row! !

!BAGridMorph methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:54'!
playground
	"Answer the grid in which this morph is placed"
	
	^ self owner! !

!BAGridMorph methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:54'!
row
	"Answer the number of the recievers column"

	^ self subclassResponsibility! !

!BAGridMorph methodsFor: 'drawing' stamp: 'AT 7/20/2007 01:56'!
updateWorldPosition
	"Calculate the new position in the world and update it"
	
	self positionRelative:
		(self column - 1)@(0 - self row) * self playground gridScale 
		+ self playground gridOffset - self anchorPoint.! !


!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 21:32'!
activate
	"Enable this block to be part of normal game action"
	
	hasMoved := true.
	chain := 0.
	isActive := true.
	gap := 0.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 19:36'!
addToPlayground: aTAPlayground

	^ self subclassResponsibility! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:09'!
bottomBlock
	
	^ bottomBlock! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:09'!
bottomBlock: anObject
	
	bottomBlock := anObject! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:09'!
chain

	^ chain.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:02'!
chainBonus: anInteger

	chain := chain max: anInteger.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/18/2007 01:39'!
chain: anInteger

	chain := anInteger! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:02'!
delayFallingBy: aFloat

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:09'!
gap
	
	^ gap! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 00:43'!
gap: aFloat

	gap := aFloat.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:09'!
hasMoved

	^ hasMoved! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 20:37'!
ifFloating: aBlock
	
	^ self isFloating ifTrue: [aBlock value].! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:03'!
ifMarked: aBlock
	
	^ self isMarked ifTrue: [aBlock value].! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:03'!
ifNotBlocked: aBlock

	^ self isBlocked ifFalse: [aBlock value].! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:10'!
isActive
	"Answer true if the block can be active part of the game (swap, sweep, etc)"
	
	^ isActive.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 6/14/2007 23:53'!
isBlocked
	"Answer whether the block is locked"
	
	^ false.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:10'!
isColoredBlock
	"Answer true if this is a simple colored block"
	
	^ false.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 6/14/2007 23:53'!
isEmpty
	"Answer whether the block is an empty block"
	
	^ self subclassResponsibility.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:58'!
isFloating
	"Answer true if the block is falling"
	
	^ self subclassResponsibility.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:10'!
isMarked

	^ isMarked.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/12/2007 16:30'!
mark: chainBonus
	"Mark this block to be sweeped"
	
	chain := chainBonus.
	isMarked := true.! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/19/2007 23:59'!
neighbor: aPoint

	^ self playground block: 
		self gridPosition + aPoint + (0@(self size-1))! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:28'!
score

	^ 0! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:10'!
size
	"Answer the height of the block in grid units."
	
	^ 1! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:04'!
startFloating

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:04'!
stopFloating

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/5/2007 23:54'!
tolerance
	"Answer the height tolerance in grid units for swapping falling blocks"

	^ 0.25! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:11'!
topBlock

	^ topBlock! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 23:11'!
topBlock: anObject

	topBlock := anObject! !

!BAAbstractBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 21:34'!
type
	"Answer a symbol representing the type of the reciever."
	
	^ nil! !

!BAAbstractBlock methodsFor: 'column control' stamp: 'AT 7/5/2007 22:26'!
blockAtHeight: aFloat

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'column control' stamp: 'AT 7/5/2007 20:58'!
blocksDo: aBlock

	^ self subclassResponsibility! !

!BAAbstractBlock methodsFor: 'column control' stamp: 'AT 7/6/2007 00:02'!
blockUnder

	^ self subclassResponsibility! !

!BAAbstractBlock methodsFor: 'column control' stamp: 'AT 7/6/2007 00:35'!
highestRow

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 21:29'!
connectWith: aTABlock
	"Create links between the reciever and the given block. The reciever will be on top"
	
	self bottomBlock: aTABlock.
	aTABlock topBlock: self.
! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 21:32'!
insertAbove: aTABlock gap: aFloat
	"Insert the reciever aFloat rows above aTABlock"
	
	^ self subclassResponsibility.! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:05'!
insertAt: aPoint

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:13'!
leaveColumn
	"Remove the reciever from its column"

	^ self subclassResponsibility ! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:06'!
notifyFallBy: aFloat! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/1/2007 23:15'!
notifyNeighborSweepes: aPoint
	"Notify the reciever that a neighbor block was sweeped at the relative position aPoint"! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:12'!
remove
	"Remove the reciever from the world"

	self leaveColumn.
	owner ifNotNil: [owner removeMorph: self].! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 23:22'!
replaceWith: aTABlock
	"Replace the reciever with the given block quietly (don't notify neighbors)"

	| pos pg |
	pos := self gridPosition.
	pg := self playground.
	self remove.
	(pg column: pos x) 
		insertBlock: aTABlock activate
		atHeight: pos y.
	aTABlock addToPlayground: pg.! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 2/21/2008 19:46'!
sweepReplacement

	^ BAEmptyBlock createAt: self gridPosition.! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:07'!
sweep: number of: count
	"Remove the reciever from the playground"
	
	| top |
	top := self neighbor: 0@1.
	(self playground) 
		notifyBlockSweepesAt: self gridPosition;
		addToScore: self score.
	self replaceWith: (self sweepReplacement vanishAfter: number * 0.2).
	top delayFallingBy: count+1 * 0.2.	! !

!BAAbstractBlock methodsFor: 'block control' stamp: 'AT 7/19/2007 20:31'!
vanishAfter: aFloat
	"Used by dead blocks"! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 19:58'!
findMatches: anInt
	"Find and mark matching blocks in the neighborhood of the reciever.
	 anInt specifies the chain bonus"

	^ self subclassResponsibility.! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/20/2007 01:08'!
horizontalMatches

	^ self straightMatches: 1@0! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 21:35'!
ifMatches: aTABlock do: aBlock
	"Execute the block if the reciever matches with aTABlock OR vice versa.
	part of old marking algorithm"
	
	((self matchesWith: aTABlock) or: [aTABlock matchesWith: self]) 
		ifTrue: [aBlock value]! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/20/2007 00:34'!
matches

	^ self horizontalMatches 
		addAll: self verticalMatches;
		yourself.! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 22:00'!
matchesInDirection: aPoint
	"Answer a set of matching blocks in the given direction"
	
	| next matches |
	self vetoSweeping ifTrue: [^ Set new].	
	next := self neighbor: aPoint.
	matches := (self matchesWith: next)
		ifTrue: [next matchesInDirection: aPoint]
		ifFalse: [Set new].
	^ matches add: self; yourself.
! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 22:05'!
matchesWith: aTABlock
	"Answer true if the reciever wants to be sweeped together with the given block"

	^ false
! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 20:10'!
straightMatches: aPoint
	"Answer a set of fitting blocks if there are enough to sweep in a straight line.
	The Point specifies the orientation, eg 0@1 means vertical."

	| matches |
	matches := self matchesInDirection: aPoint.
	matches addAll: (self matchesInDirection: aPoint negated).
	^ matches size > 2
		ifTrue: [matches]
		ifFalse: [Set new]! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 7/20/2007 01:08'!
verticalMatches

	^ self straightMatches: 0@1! !

!BAAbstractBlock methodsFor: 'matching' stamp: 'AT 6/28/2007 10:10'!
vetoSweeping
	"Answer true if the reciever does not want to be sweeped"
	
	^ true.! !

!BAAbstractBlock methodsFor: 'initialization' stamp: 'AT 7/1/2007 23:18'!
initialize
	
	super initialize.
	
	gap := 0.0.
	topBlock := nil.
	bottomBlock := nil.
	isMarked := false.
	isActive := false.
	hasMoved := false.
	chain := 0.
	
	! !


!BABlock methodsFor: 'block control' stamp: 'AT 7/2/2007 19:52'!
addToPlayground: aTAPlayground

	aTAPlayground addBlock: self.
	self updateWorldPosition.! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:19'!
fallBy: aFloat

	gap := gap - aFloat.
	topBlock notifyFallBy: aFloat.! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/15/2007 19:48'!
insertAbove: aTABlock gap: aFloat
	"Insert the reciever aFloat rows above aTABlock"
	
	self gap: aFloat.
	(aTABlock topBlock)
		gap: (aTABlock topBlock gap - self gap - self size);
		connectWith: self.
	self connectWith: aTABlock.	
	hasMoved := true.
	chain := 0.! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/20/2007 00:58'!
insertAt: aPoint

	(self playground column: aPoint x) 
		insertBlock: self atHeight: aPoint y.

	(self neighbor: 0@1) stopFloating.
	(gap <= 0) ifTrue: [self stopFloating].	
	self playground notifyBlockMoved.! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/20/2007 00:07'!
leaveColumn
	"Remove this block from its column"
	
	self startFloating.
	(self neighbor: 0@1) 
		chainBonus: chain;
		startFloating.	
	(self topBlock)
		gap: (self topBlock gap + self gap + self size);
		connectWith: self bottomBlock.
! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:16'!
notifyFallBy: aFloat

	self ifFloating: []! !

!BABlock methodsFor: 'block control' stamp: 'AT 7/15/2007 12:57'!
notifyNeighborSweepes: aPoint
	"Notify the reciever that a block will be sweeped at the relative position aPoint"
	
	"Get the possible chain bonus"
	(aPoint = (0@-1) and: [isMarked not]) ifTrue: [
		chain := (self neighbor: aPoint) chain + 1].! !

!BABlock methodsFor: 'column control' stamp: 'AT 2/21/2008 19:46'!
blockAtHeight: aFloat
	"Answer a BABlock being aFloat rows above the sender. answer the reciever, a higher block, or, if no block can be found, a BAEmpty- or a BABlockedBlock."

	| y |
	y := aFloat - self gap.
	(y abs < self tolerance) ifTrue: [y := 0].
	
	(y >= self size) ifTrue: [^ topBlock blockAtHeight: y-self size].
	(y between: 0 and: (self size - 1)) ifTrue: [^ self].
	(y abs < 1) ifTrue: [^ BABlockedBlock create].
	^ BAEmptyBlock create
! !

!BABlock methodsFor: 'column control' stamp: 'AT 7/5/2007 20:57'!
blocksDo: aBlock

	aBlock value: self.
	topBlock blocksDo: aBlock.! !

!BABlock methodsFor: 'column control' stamp: 'AT 7/19/2007 23:36'!
blockUnder: aFloat
	"Answer the highest block with its top under aFloat rows above the sender"

	| y |
	y := aFloat - self gap.
	(y < 0) ifTrue: [^ self bottomBlock].
	^ topBlock blockUnder: y - self size.! !

!BABlock methodsFor: 'column control' stamp: 'AT 7/6/2007 00:36'!
highestRow

	^ topBlock highestRow + self gap + self size! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 21:33'!
column
	"Answer the number of the column of this block"
	
	^ bottomBlock column.! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/19/2007 23:47'!
delayFallingBy: aFloat
	"Do not fall in the next aFloat seconds"
	
	self fallingDelay: (fallingDelay max: aFloat).

	! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/19/2007 23:48'!
fallingDelay: aFloat
	"Do not fall in the next aFloat seconds"
	
	aFloat < 0 ifTrue: [^ self fallingDelay: 0].
	fallingDelay := aFloat.

	! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/19/2007 23:23'!
isBlocked

	^ self isFloating! !

!BABlock methodsFor: 'accessing' stamp: 'mk 6/20/2007 21:34'!
isEmpty
	"Answer whether the block is an empty block"
	
	^ false! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:54'!
isFalling
	"Answer true if the block is falling"
	
	^ (gap > 0)
		ifTrue: [fallingDelay = 0]
		ifFalse: [bottomBlock isFalling]! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 00:53'!
isFloating

	^ fallingDelay > 0! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 19:52'!
row

	^ self isActive 
		ifTrue: [self bottomBlock row + self gap + self size] 
		ifFalse: [0].! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:31'!
score

	^ 15! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 00:07'!
startFloating

	self isFalling ifFalse: [self delayFallingBy: 0.2]! !

!BABlock methodsFor: 'accessing' stamp: 'AT 7/19/2007 23:24'!
stopFloating
	
	fallingDelay := 0.! !

!BABlock methodsFor: 'matching' stamp: 'AT 7/20/2007 00:56'!
findMatches: anInt
	"Find and mark matching blocks in the neighborhood of the reciever.
	 anInt specifies the chain bonus"

	self ifFloating: [^ self].
	chain := chain max: anInt.		
	(self neighbor: 0@1) findMatches: chain.
	self matches do: [ :block | block mark: chain].
	hasMoved := false.
	isMarked ifFalse: [chain := 0].! !

!BABlock methodsFor: 'matching' stamp: 'AT 7/15/2007 12:41'!
vetoSweeping

	^ self isFalling or: [self isBlocked].! !

!BABlock methodsFor: 'initialization' stamp: 'AT 7/15/2007 19:49'!
initialize

	super initialize.
	fallingDelay := 0.! !

!BABlock methodsFor: 'stepping' stamp: 'AT 7/20/2007 00:59'!
step: seconds
	 
	self 
		updateFloating: seconds;
		tryFall: seconds;
		tryRaise: seconds.! !

!BABlock methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:19'!
tryFall: seconds
	"Move the block down if necessary"
	
	self ifFloating: [^ self].
	
	((gap > 0) and: [(bottomBlock isFalling) not]) ifTrue: [
		| fall |
		fall := self playground fallingSpeed * seconds.
		(fall >= gap) ifTrue: [
			fall := gap.	
			hasMoved := true].
		self fallBy: fall].! !

!BABlock methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:59'!
tryRaise: seconds
	"Move block up if necessary"
	
	(gap < 0) ifTrue: [
		isActive 
			ifTrue: [gap := 0]
			ifFalse: [
				gap := gap + (self playground raisingSpeed * seconds).
				(gap >= 0) ifTrue: [
					self playground notifyLineAppeared]]]! !

!BABlock methodsFor: 'stepping' stamp: 'AT 7/20/2007 01:00'!
updateFloating: seconds
	 
	fallingDelay > 0 ifTrue: [
		self fallingDelay: fallingDelay - seconds].! !


!BAColoredBlock methodsFor: 'accessing' stamp: 'NR 6/25/2007 23:48'!
activate
	"Enable this block to be part of normal game action and show the default Image"
	
	super activate.
	self updateSkin.
	! !

!BAColoredBlock methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 15:42'!
disabledImageName
	"Answer the image of a disabled box"
	
	^ 'boxes', FileDirectory slash, type, '_disabled'! !

!BAColoredBlock methodsFor: 'accessing' stamp: 'NR 6/29/2007 18:25'!
isColoredBlock

	^ true! !

!BAColoredBlock methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 15:42'!
standardImageName
	"Answer the standard image of a box"
	
	^ 'boxes',FileDirectory slash, type! !

!BAColoredBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:22'!
type
	"Answer a symbol representing the type of the reciever."
	
	^ type! !

!BAColoredBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:22'!
type: anObject
	
	type := anObject! !

!BAColoredBlock methodsFor: 'skin support' stamp: 'AT 7/2/2007 22:22'!
imageName

	^ self isActive 
		ifTrue: [self standardImageName] 
		ifFalse: [self disabledImageName]! !

!BAColoredBlock methodsFor: 'block control' stamp: 'AT 7/1/2007 21:31'!
matchesWith: aTABlock
	"Answer true if the reciever wants to be sweeped with the given block."
	
	^ aTABlock isColoredBlock 
		ifTrue: [aTABlock type = self type] 
		ifFalse: [false]! !

!BAColoredBlock methodsFor: 'block control' stamp: 'AT 2/21/2008 19:46'!
sweepReplacement

	^ BADeadBlock new imageName: self disabledImageName.! !


!BACursor methodsFor: 'accessing' stamp: 'AT 6/21/2007 21:34'!
anchorPoint

	^ 1@1! !

!BACursor methodsFor: 'accessing' stamp: 'AT 7/3/2007 09:55'!
column

	^ xPos! !

!BACursor methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:52'!
newLineNotification

	yPos := yPos +1.! !

!BACursor methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:55'!
row
	
	(yPos > self playground maxRow) ifTrue: [yPos := yPos-1].
	^ yPos! !

!BACursor methodsFor: 'initialization' stamp: 'AT 7/6/2007 00:53'!
initialize
	
	super initialize.
	self resetPosition.! !

!BACursor methodsFor: 'initialization' stamp: 'AT 7/3/2007 09:55'!
resetPosition

	xPos := 3.
	yPos := 1.! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/3/2007 09:56'!
moveDown

	(yPos > 1) ifTrue: [yPos := yPos-1].
! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/3/2007 09:56'!
moveLeft

	(xPos > 1) ifTrue: [xPos := xPos-1].
! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/3/2007 09:56'!
moveRight

	(xPos < 5) ifTrue: [xPos := xPos+1].! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/3/2007 09:56'!
moveUp

	yPos < (self playground maxRow-1) 
		ifTrue: [yPos := yPos+1].! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/6/2007 00:54'!
nextLine
	
	self playground nextLine.! !

!BACursor methodsFor: 'movement' stamp: 'AT 7/6/2007 00:54'!
swapBlocks
	"Swap blocks under cursor"

	self playground swapRightAt: xPos@yPos.
! !


!BADeadBlock methodsFor: 'misc' stamp: 'AT 7/19/2007 20:36'!
initialize
	
	super initialize.
	delay := 0.! !

!BADeadBlock methodsFor: 'misc' stamp: 'AT 7/20/2007 01:13'!
isFloating

	^ true! !

!BADeadBlock methodsFor: 'misc' stamp: 'AT 7/19/2007 20:25'!
step: seconds

	delay := delay - seconds.
	delay > 0 ifFalse: [self remove]! !

!BADeadBlock methodsFor: 'misc' stamp: 'AT 7/19/2007 20:32'!
vanishAfter: aFloat
	"Set the time in seconds after which the reciever disappeares"

	delay := aFloat! !


!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 19:36'!
addToPlayground: aTAPlayground
! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 10:16'!
column

	^ column! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:02'!
delayFallingBy: aFloat! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/5/2007 21:28'!
gap

	^ row - (bottomBlock ifNil: [0] ifNotNil: [bottomBlock row])! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 19:29'!
gridPosition: aPoint

	column := aPoint x.
	row := aPoint y.! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 21:27'!
hasMoved

	^ false! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 21:27'!
isEmpty
	
	^ true! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:44'!
isFalling
	
	^ false.! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:58'!
isFloating

	^ false! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/1/2007 21:27'!
isMarked
	
	^ false.! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 6/20/2007 13:42'!
row

	^ row! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:04'!
startFloating! !

!BAEmptyBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:04'!
stopFloating! !

!BAEmptyBlock methodsFor: 'column control' stamp: 'AT 2/21/2008 19:46'!
blockAtHeight: aFloat

	^ BAEmptyBlock create! !

!BAEmptyBlock methodsFor: 'column control' stamp: 'AT 7/5/2007 20:58'!
blocksDo: aBlock! !

!BAEmptyBlock methodsFor: 'column control' stamp: 'AT 7/6/2007 00:12'!
blockUnder: aFloat

	^ self bottomBlock! !

!BAEmptyBlock methodsFor: 'column control' stamp: 'AT 7/6/2007 00:36'!
highestRow

	^ 0! !

!BAEmptyBlock methodsFor: 'matching' stamp: 'AT 7/2/2007 22:26'!
findMatches: anInt
! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:24'!
insertAbove: aTABlock gap: aFloat
	"Empty blocks don't participate block control actions"
! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:05'!
insertAt: aPoint! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:24'!
leaveColumn
	"Empty blocks don't participate block control actions"! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/1/2007 21:28'!
matchesWith: aBlock

	^ false.! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:25'!
moveTo: aPoint
	"Empty blocks don't participate block control actions"! !

!BAEmptyBlock methodsFor: 'block control' stamp: 'AT 7/20/2007 01:06'!
notifyFallBy: aFloat! !


!BABlockedBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:08'!
isBlocked

	^ true.! !


!BAHelpDialog methodsFor: 'initialization' stamp: 'AT 7/20/2007 01:27'!
initialize

	pageNumber := 0.
	super initialize.! !

!BAHelpDialog methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 16:37'!
nextIcon

	pageNumber := pageNumber + 1.
	pageNumber > self class pageCount ifTrue: [^ self close]. 
	^ BAMorph withStoredForm: 'dialog' , FileDirectory slash , 'help', pageNumber stringRepresentation! !


!BAKeyDialog methodsFor: 'initialization' stamp: 'AT 7/20/2007 01:30'!
initialize

	keys := RunArray new.
	super initialize.! !

!BAKeyDialog methodsFor: 'event handling' stamp: 'AT 7/15/2007 23:55'!
keyEvent: anEvent

	| key |
	key := {anEvent keyValue}.
	keys indexOf: key ifAbsent: [
		keys addLast: key.
		keys size = 6
			ifTrue: [
				action value: keys value: owner.
				self close]
			ifFalse: [icon replaceWith: (icon := self nextIcon)]].! !

!BAKeyDialog methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 16:37'!
nextIcon

	^ BAMorph withStoredForm: 'dialog' , FileDirectory slash , 'keys', 
		(keys size+1) stringRepresentation ! !


!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:04'!
activeEntry

	^ entries at: selection ifAbsent: [nil]
	
! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:04'!
activeMenu

	^ (activeMenu == self) 
		ifTrue: [self]
		ifFalse:[activeMenu activeMenu]
! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:56'!
adjustLeftIndex
	"Move the visible part of the menu to the selection, 
	answer true if something happened"
	
	| old |
	old := leftIndex.
	[selection < self leftIndex] whileTrue: [
		leftIndex := leftIndex - 1].
	[selection > self rightIndex] whileTrue: [
		leftIndex := leftIndex + 1].		
	^ (old = leftIndex) not.! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:57'!
idealVisibleEntries
	"Answer the number of entries shown 
	when the menu is collapsed"

	^ 4! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:06'!
keyboardDictionary

	^ keyboardDictionary
			ifNotNil: [keyboardDictionary]
			ifNil: [parentMenu keyboardDictionary]! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:06'!
keyboardDictionary: aDictionary

	keyboardDictionary := aDictionary! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 11:45'!
leftIndex
	"Anser the index if the leftmost visible entry"

	^ self scrollingActive 
		ifTrue: [leftIndex]
		ifFalse: [1]! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:11'!
maxVisibleEntries
	"Answer the maximum number of entries visible at a time"

	^ 5! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:06'!
menuItemCount

	^ entries size.! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:06'!
parentMenu

	^ parentMenu
	! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/6/2007 00:57'!
parentMenu: aMenu
	"Set the parent menu and maintain a return entry"

	(aMenu isNil and: [parentMenu isNil not])
		ifTrue: [self removeReturnEntry].
	(aMenu isNil not and: [parentMenu isNil])
		ifTrue: [self addReturnEntry].
	parentMenu := aMenu.
! !

!BAMenu methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 16:38'!
refreshBorder

	leftBorder imageName: ('menu' , FileDirectory slash , 'left',
		(self leftIndex > 1 ifTrue: ['_scroll'] ifFalse: [''])).
	rightBorder 	imageName: ('menu' , FileDirectory slash , 'right',
		(self rightIndex < entries size ifTrue: ['_scroll'] ifFalse: [''])).! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 11:45'!
rightIndex
	"Anser the index if the rightmost visible entry"

	^ self scrollingActive 
		ifTrue: [leftIndex + self idealVisibleEntries-1]
		ifFalse: [entries size]! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 11:12'!
scrollingActive

	^ leftIndex > 0.! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 11:57'!
scrollingActive: aBool

	leftIndex := aBool ifTrue: [1] ifFalse: [0].
	self showEntries.! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:16'!
selection

	^ selection! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 11:30'!
selection: anInteger

	(selection = 0) ifFalse: [self activeEntry active: false].
	selection := ((anInteger - 1) \\ self menuItemCount) + 1.
	self refresh.! !

!BAMenu methodsFor: 'accessing' stamp: 'AT 7/3/2007 10:17'!
tetrisAttack

	^ owner.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 10:17'!
addEntryFirst: aTAMenuEntry 

	entries addFirst: aTAMenuEntry.
	self 
		addMorph: aTAMenuEntry inFrontOf: leftBorder;
		entryAdded.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 10:18'!
addEntryLast: aTAMenuEntry 

	entries addLast: aTAMenuEntry.
	self 
		addMorph: aTAMenuEntry behind: rightBorder;
		entryAdded.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 2/21/2008 19:36'!
addEntryWithSkin: aString

	self addEntryLast: 
		(BAMenuEntry createWithSkin: aString).
	"Select the entry if it represents the current skin"
	BlockAttack currentSkin = aString ifTrue: [
		self selection: (entries size)].! !

!BAMenu methodsFor: 'entries' stamp: 'AT 2/21/2008 19:32'!
addEntry: aString withAction: aBlock

	self addEntryLast: 
		(BAMenuEntry create: aString withAction: aBlock).! !

!BAMenu methodsFor: 'entries' stamp: 'AT 2/21/2008 19:33'!
addEntry: aString withSubmenu: aBlock

	self addEntryLast: 
		(BAMenuEntry create: aString withSubMenu: aBlock).
! !

!BAMenu methodsFor: 'entries' stamp: 'AT 2/21/2008 19:33'!
addReturnEntry

	selection := selection + 1.
	self addEntryFirst: BAMenuEntry createReturn.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 10:20'!
doActiveAction
	"Call the action of the selected entry"

	self activeEntry doAction: self.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:59'!
entryAdded
	"Activate the scroll mode if necessary"

	(entries size > self maxVisibleEntries) 
		ifTrue: [self scrollingActive: true]
		ifFalse: [self showEntries].
! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 12:00'!
entryRemoved
	"Deactivate the scroll mode if necessary"
	
	self menuItemCount <= self maxVisibleEntries 
		ifTrue: [self scrollingActive: false]
		ifFalse: [self showEntries].! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:18'!
hideAllEntries

	entries do: [ :entry | self removeMorph: entry].! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 10:31'!
nextEntry

	self selection: self selection + 1.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 10:31'!
prevEntry

	self selection: self selection - 1.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:58'!
refresh
	"Update entries"

	(self scrollingActive and: [self adjustLeftIndex]) 
		ifTrue: [self showEntries]
		ifFalse: [self activeEntry active: true].! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:52'!
removeEntry: anInt

	selection > anInt ifTrue: [selection := selection - 1].
	leftIndex > anInt ifTrue: [leftIndex := leftIndex - 1].
	self removeMorph: (entries at: anInt).
	entries remove: (entries at: anInt).
	self entryRemoved.	! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:49'!
removeReturnEntry

	self removeEntry: 1.! !

!BAMenu methodsFor: 'entries' stamp: 'AT 7/3/2007 11:57'!
showEntries
	"Show all entries in the visible range"

	self hideAllEntries.
	self leftIndex to: self rightIndex do: [ :i |
		self addMorph: (entries at: i) behind: rightBorder].
	self refreshBorder.
	self activeEntry active: true.! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 7/6/2007 01:07'!
addKeysFromArray: anArray

	self
		addKeys: (anArray at: 3) forAction: 
			[:menu | menu prevEntry]; "left"
		addKeys: (anArray at: 4) forAction: 
			[:menu | menu nextEntry]; "right"
		addKeys: (anArray at: 5) forAction: 
			[:menu | menu doActiveAction]. "select (swap button)"
! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 7/6/2007 01:06'!
addKeys: aKeyArray forAction: aBlock
	
	aKeyArray do: [:key | 
		self keyboardDictionary at: key put: aBlock].! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 7/6/2007 12:05'!
initialize

	super initialize.
	self 
		hide;
		initializeInstanceVars;
		initializeLayout;
		addMorph: leftBorder;
		addMorph: rightBorder.! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:33'!
initializeInstanceVars

	entries := RunArray new.
	activeMenu := self.	
	selection := 1.
	leftIndex := 0.
	leftBorder := BAMorph menuLeft.
	rightBorder := BAMorph menuRight.! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:35'!
initializeKeys
	"To prevent side effects of control changings, 
	this should only be called when initializing a playground"
	
	keyboardDictionary := Dictionary new.
	self addKeysFromArray: BlockAttack player1Keys.
	self addKeysFromArray: BlockAttack player2Keys.! !

!BAMenu methodsFor: 'initialization' stamp: 'AT 7/3/2007 13:04'!
initializeLayout

	self
		layoutPolicy: TableLayout new;
		listDirection: #rightToLeft;
		listCentering: #center;
		layoutInset: 0; cellInset: 0.
! !

!BAMenu methodsFor: 'menu control' stamp: 'AT 7/3/2007 13:05'!
close

	parentMenu ifNotNil: [parentMenu closeSubmenu]! !

!BAMenu methodsFor: 'menu control' stamp: 'AT 7/3/2007 13:06'!
closeSubmenu

	activeMenu == self ifFalse: [
		activeMenu closeSubmenu.
		owner removeMorph: activeMenu.
		activeMenu := self.
		self show]! !

!BAMenu methodsFor: 'menu control' stamp: 'AT 7/3/2007 13:06'!
hide

	self visible: false.! !

!BAMenu methodsFor: 'menu control' stamp: 'AT 7/3/2007 13:06'!
show

	self visible: true.
	self activeEntry active: true.! !

!BAMenu methodsFor: 'menu control' stamp: 'AT 7/3/2007 13:06'!
showSubmenu: aMenu

	self hide.
	aMenu parentMenu: self.
	activeMenu := aMenu.
	owner addMorphCentered: aMenu.
	aMenu show.! !

!BAMenu methodsFor: 'event handling' stamp: 'AT 7/12/2007 16:10'!
handleMouseDown: anEvent

	anEvent wasHandled ifFalse: [
		anEvent position x < (self left + (self width / 2))
			ifTrue: [self prevEntry ]
			ifFalse: [self nextEntry].
		anEvent wasHandled: true].! !

!BAMenu methodsFor: 'event handling' stamp: 'AT 7/12/2007 16:04'!
handlesMouseDown: anEvent

	^ true! !

!BAMenu methodsFor: 'event handling' stamp: 'AT 7/15/2007 23:38'!
keyEvent: anEvent
	"Handle incoming keyEvent, 
	do nothing if no valid key was pressed"
	
	activeMenu = self 
		ifTrue: [
			(self keyboardDictionary 
				at: anEvent keyValue 
				ifAbsent: [[:menu|]]) value: self]
		ifFalse: [
			activeMenu keyEvent: anEvent].
	! !

!BAMenu methodsFor: 'skin support' stamp: 'AT 7/3/2007 13:07'!
updateSkin

	super updateSkin.
	self activeEntry ifNotNil: [
		self activeEntry active: true].! !


!BAMenuEntry methodsFor: 'accessing' stamp: 'AT 7/3/2007 13:09'!
action

	^ action! !

!BAMenuEntry methodsFor: 'accessing' stamp: 'AT 2/21/2008 19:35'!
active: aBoolean

	icon image: (BlockAttack 
		imageForm: (self imagePath: aBoolean), name 
		fromSkin: self skin).	
	icon moveToCenter.

! !

!BAMenuEntry methodsFor: 'accessing' stamp: 'AT 7/3/2007 13:12'!
doAction: aTAMenu

	^ action value: aTAMenu.! !

!BAMenuEntry methodsFor: 'accessing' stamp: 'AT 7/3/2007 13:10'!
icon

	^ icon! !

!BAMenuEntry methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 16:39'!
imagePath: aBoolean

	^ 'menu' , FileDirectory slash , (aBoolean ifTrue: ['active' , FileDirectory slash] ifFalse: ['inactive' , FileDirectory slash])! !

!BAMenuEntry methodsFor: 'accessing' stamp: 'AT 2/21/2008 19:35'!
updateSkin

	name = 'skin' ifFalse: [
		super updateSkin. 
		^ self active: false].
		
	self "Update skin careful when showing a skin preview"
		image: (BlockAttack 
						imageForm: self imageName 
						fromSkin: self skin);
		active: false.
! !

!BAMenuEntry methodsFor: 'initialization' stamp: 'AT 7/3/2007 13:09'!
action: aBlock

	action := aBlock.! !

!BAMenuEntry methodsFor: 'initialization' stamp: 'AT 7/3/2007 13:14'!
initialize

	super initialize.
	self initializeImage: 'skin'.! !

!BAMenuEntry methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:33'!
initializeImage: aString

	icon ifNotNil: [self removeMorph: icon].
	icon := BAMorph empty.
	name := aString.
	self 
		addMorphCentered: icon;
		active: false.! !

!BAMenuEntry methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:35'!
skin: aString

	| preview |
	self action: [ :menu | menu tetrisAttack loadSkin: aString].
	self initializeImage: 'skin'.
	preview := BAMorph empty.
	icon addMorph: preview.
	preview 
		image: (BlockAttack imageForm: 'thumbnail' fromSkin: aString);
		moveToCenter.! !

!BAMenuEntry methodsFor: 'initialization' stamp: 'AT 7/3/2007 13:11'!
submenu: aBlock

	self action: [:menu | menu showSubmenu: aBlock value].! !

!BAMenuEntry methodsFor: 'event handling' stamp: 'AT 7/12/2007 16:03'!
handleMouseDown: anEvent

	self doAction: self owner.
	anEvent wasHandled: true.! !

!BAMenuEntry methodsFor: 'event handling' stamp: 'AT 7/12/2007 15:58'!
handlesMouseDown: anEvent

	^ true! !


!BAMorph class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
empty
	^ self withStoredForm: 'misc' , FileDirectory slash , 'empty'! !

!BAMorph class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
menuLeft

	^ self withStoredForm: 'menu' , FileDirectory slash , 'left'! !

!BAMorph class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
menuRight

	^ self withStoredForm: 'menu' , FileDirectory slash , 'right'! !

!BAMorph class methodsFor: 'instance creation' stamp: 'AT 6/24/2007 17:36'!
withForm: aForm
	"Answer a TAMorph instance created from a form"

	^ (self new) image: aForm! !

!BAMorph class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:31'!
withStoredForm: aFormIdentifier
	"Answer a TAMorph instance created from 
	a form stored in the TetrisAttack image db"

	^ (self new) imageName: aFormIdentifier! !


!BAAbstractDialog class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:36'!
create

	^ (self new) imageName: 'dialog' , FileDirectory slash , 'dialog'! !

!BAAbstractDialog class methodsFor: 'instance creation' stamp: 'AT 7/20/2007 01:24'!
createForPuzzleGame

	^ (self create)
		action: [ :password :tetrisAttack | 
			tetrisAttack menu tetrisAttack newPuzzleGame: password].! !


!BAAbstractPlayground class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:36'!
create
	"Answer a new TAPlayGround"  
	
	^ self withStoredForm: 'misc' , FileDirectory slash , 'playground'! !

!BAAbstractPlayground class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:53'!
createForPlayer1
	
	^ self createForPlayer: 
		(BAHumanPlayer new) setPlayer1Initialization! !

!BAAbstractPlayground class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:53'!
createForPlayer2
	
	^ self createForPlayer: 
		(BAHumanPlayer new) setPlayer2Initialization! !

!BAAbstractPlayground class methodsFor: 'instance creation' stamp: 'AT 7/5/2007 16:07'!
createForPlayer: aTAPlayer
	
 	^ (self create) gameplayer: aTAPlayer.! !


!BAColoredBlock class methodsFor: 'accessing' stamp: 'AT 7/5/2007 19:38'!
blockTypes
	"Answer block types available"

	^ #(#red #green #blue #pink #yellow #cyan)! !

!BAColoredBlock class methodsFor: 'accessing' stamp: 'AT 7/5/2007 19:41'!
blockTypesIn: aDifficultyLevel
	"Answer the block types available in a certain difficulty level"

	^ aDifficultyLevel = #hard
		ifTrue: [self blockTypes]
		ifFalse: [self blockTypes allButLast]

		! !

!BAColoredBlock class methodsFor: 'instance creation' stamp: 'AT 7/5/2007 19:42'!
create: aType

	^ (self new)
		type: aType.
! !

!BAColoredBlock class methodsFor: 'instance creation' stamp: 'AT 7/5/2007 19:36'!
randomType

	^ self randomTypeBut: {}! !

!BAColoredBlock class methodsFor: 'instance creation' stamp: 'AT 7/5/2007 16:32'!
randomTypeBut: aCollection
	"Create a block with random type except for the colors in the collection"
	
	^ self 
		randomTypeOf: (self blockTypesIn: #normal) 
		but: aCollection! !

!BAColoredBlock class methodsFor: 'instance creation' stamp: 'AT 7/5/2007 19:35'!
randomTypeOf: colors but: except
	
	| type |
	[type := colors atRandom] doWhileTrue: 
		[except anySatisfy: [ :each | each = type]].
	^ self create: type.! !


!BACursor class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:37'!
create

	^ self withStoredForm: 'misc' , FileDirectory slash , 'catcher'! !


!BAEmptyBlock class methodsFor: 'as yet unclassified' stamp: 'AT 7/1/2007 19:30'!
create
	"Answers a TAEmptyBlock instance"
	
	^ self createAt: 0@0.
! !

!BAEmptyBlock class methodsFor: 'as yet unclassified' stamp: 'AT 7/1/2007 19:30'!
createAt: aPoint
	"Answers a TAEmptyBlock instance which remembers its position"
	
	^ (self new) gridPosition: aPoint.
! !


!BAHelpDialog class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:37'!
create

	^ (self new) imageName: 'dialog' , FileDirectory slash , 'help'! !

!BAHelpDialog class methodsFor: 'instance creation' stamp: 'ds 7/19/2007 20:56'!
createHelp

	^ (self create)
		action: [ :password :tetrisAttack | 
			tetrisAttack menu tetrisAttack newPuzzleGame: password].! !

!BAHelpDialog class methodsFor: 'instance creation' stamp: 'ds 7/20/2007 14:42'!
pageCount
	^ 6! !


!BAKeyDialog class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:37'!
create

	^ (self new) imageName: 'dialog' , FileDirectory slash , 'dialog'! !

!BAKeyDialog class methodsFor: 'instance creation' stamp: 'AT 7/15/2007 23:55'!
createPlayer1Keys

	^ (self create)
		action: [ :keys :tetrisAttack | tetrisAttack setPlayer1Keys: keys].! !

!BAKeyDialog class methodsFor: 'instance creation' stamp: 'AT 7/15/2007 23:55'!
createPlayer2Keys

	^ (self create)
		action: [ :keys :tetrisAttack | tetrisAttack setPlayer2Keys: keys].! !


!BAMenu class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:38'!
create

	^ self withStoredForm: 'menu' , FileDirectory slash , 'background'! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:11'!
createDefaultGameMenu

	^ self createMainMenu! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:11'!
createDifficultyMenu: aBlock
	"Create a menu wich executes the block with the 
	selected difficulty as second parameter"

	^	(self create) 		
		addEntry: 'easy' withAction: [:menu | 
			aBlock value: menu value: #easy];
		addEntry: 'normal' withAction:  [:menu |
			aBlock value: menu value: #normal];
		addEntry: 'hard' withAction: [:menu | 
			aBlock value: menu value: #hard];
		selection: 2.! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:41'!
createMainMenu

	^ (self create) 
		addEntry: 'one-player' withSubmenu: [self createOnePlayerMenu];
		addEntry: 'two-players' withSubmenu: [self createTwoPlayerMenu];
		addEntry: 'puzzle' withSubmenu: [self createPuzzleMenu];
		addEntry: 'options' withSubmenu: [self createSettingsMenu];
		addEntry: 'help' withSubmenu: [BAHelpDialog createHelp];
		addEntry: 'exit' withAction: [ :menu | menu tetrisAttack quit];
		selection: 1.! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:19'!
createOnePlayerMenu

	^ self createDifficultyMenu: [:menu :value |
		menu tetrisAttack newSinglePlayerGame: value]! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:43'!
createPuzzleMenu

	^ (self create)
		addEntry: 'easy' withAction: [ :menu | 
			menu tetrisAttack newPuzzleGame: 1];
		addEntry: 'password' withSubmenu: [
			BAPasswordDialog createForPuzzleGame];
		selection: 1.! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:43'!
createSettingsMenu

	^ (self create) 
		addEntry: 'player1keys' withSubmenu: [BAKeyDialog createPlayer1Keys];
		addEntry: 'player2keys' withSubmenu: [BAKeyDialog createPlayer2Keys];
		addEntry: 'skins' withSubmenu: [self createSkinsMenu];
		selection: 1.! !

!BAMenu class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:36'!
createSkinsMenu

	| menu |
	menu := self create.
	BlockAttack skins keysDo: [ :key |
		menu addEntryWithSkin: key].
	^ menu! !

!BAMenu class methodsFor: 'instance creation' stamp: 'ds 7/20/2007 23:45'!
createTwoPlayerMenu

	^ self createDifficultyMenu: [ :menu :value |
		menu tetrisAttack newVersusGame: value]! !


!BAMenuEntry class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:39'!
create

	^ self withStoredForm: 'menu' , FileDirectory slash , 'entry'! !

!BAMenuEntry class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:01'!
createReturn

	^ self create: 'return' withAction: [:menu | menu close]! !

!BAMenuEntry class methodsFor: 'instance creation' stamp: 'AT 7/3/2007 13:17'!
createWithSkin: aString

	^ (self create) skin: aString.
! !

!BAMenuEntry class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 01:26'!
create: aString withAction: aBlock

	^ (self create) 
		initializeImage: aString; 
		action: aBlock.! !

!BAMenuEntry class methodsFor: 'instance creation' stamp: 'AT 6/22/2007 08:46'!
create: aString withSubMenu: aBlock

	^ (self create)
		initializeImage: aString;
		submenu: aBlock.! !


!BAPasswordDialog methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:36'!
initialize

	password := 0.
	keys := BlockAttack player1Keys.
	super initialize.! !

!BAPasswordDialog methodsFor: 'event handling' stamp: 'AT 7/20/2007 01:31'!
keyEvent: anEvent

	| key |
	key := 0.
	1 to: 4 do: [:i |
		((keys at: i) indexOf: anEvent keyValue ifAbsent: [0]) > 0
		ifTrue: [key := i]].
	key > 0 ifTrue: [
		password := password * 10 + key.
		password > 100000
			ifTrue: [
				action value: password value: owner.
				self close]
			ifFalse: [icon replaceWith: (icon := self nextIcon)]].! !

!BAPasswordDialog methodsFor: 'accessing' stamp: 'rkrk 5/9/2008 16:40'!
nextIcon

	^ BAMorph withStoredForm: 'dialog' , FileDirectory slash , 'pw', 
		((password+0.1*100) log floor) stringRepresentation ! !


!BAPasswordDialog class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
create

	^ (self new) imageName: 'dialog' , FileDirectory slash , 'dialog'! !

!BAPasswordDialog class methodsFor: 'instance creation' stamp: 'AT 7/16/2007 11:08'!
createForPuzzleGame

	^ (self create)
		action: [ :password :tetrisAttack | 
			tetrisAttack menu tetrisAttack newPuzzleGame: password].! !


!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:11'!
columns

	^ columns! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:18'!
columns: anArray

	columns := anArray.! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 6/23/2007 16:23'!
column: anInt

	^ columns at: anInt! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/9/2007 22:53'!
copy

	^ (self class new)
		id: self id;
		columns: self columns copy;
		count: self count;
		passwordHash: self passwordHash;
		score: self score! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/9/2007 23:02'!
copy: anInt

	^ (self copy) score: anInt! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/3/2007 17:49'!
count

	^ count! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/3/2007 17:49'!
count: anInt

	count := anInt! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:12'!
hasPassword: aPasswordString
	"Answer whether the arguments hash is like passwordHash"
	
	^ (passwordHash == aPasswordString hash)! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:12'!
id

	^ id! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:18'!
id: anInteger

	id := anInteger.! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:11'!
passwordHash

	^ passwordHash! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'NR 6/22/2007 16:10'!
passwordHash: anInteger

	passwordHash := anInteger! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/9/2007 22:48'!
score

	^ score ifNil: [0] ifNotNil: [score]! !

!BAPuzzleLevel methodsFor: 'accessing' stamp: 'AT 7/9/2007 22:47'!
score: anInt

	score := anInt! !


!BAPuzzleLevel class methodsFor: 'instance creation' stamp: 'NR 6/22/2007 16:09'!
create: aLevelId

	^ (self new) id: aLevelId! !


!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/18/2007 01:31'!
checkGameOver

	self checkWin ifFalse: [
		swapCount = 0 ifTrue: [
			self allBlocksDo: [ :block |
				(block gap > 0 or: [block isBlocked])
					ifTrue: [^ self]].
			self tetrisAttack notifyGameOver]]! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/16/2007 21:53'!
checkWin
	(columns allSatisfy: [ :column | 
		column height = 0])
			ifTrue: [
				self gotoLevel: (level+1).
				^ true].
	^ false.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:36'!
difficulty: password
	
	history := RunArray new.
	history addLast: (BlockAttack levelByPassword: password).
	self stepBack.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/16/2007 22:20'!
fallingSpeed

	^ 6.0! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/9/2007 23:14'!
gameOver

	history := history first: 1.
	self stepBack.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:36'!
gotoLevel: anInt

	cursor resetPosition.
	history := RunArray new.
	history addLast: ((BlockAttack puzzleLevel: anInt) copy: score).
	self stepBack
	! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:21'!
levelUp
	"No score related level ups"! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:45'!
loadPuzzle: aPuzzle

	score := aPuzzle score.
	self clear;
		level: aPuzzle id;
		swapCount: aPuzzle count.
	1 to: 6 do: [ :x |
		(aPuzzle column: x) do: [ :type |
			(self column: x) insertAtTop: 
				(BAColoredBlock create: type)]].
	self allBlocksDo: [ :block | block addToPlayground: self];
		updateStatusDisplay;
		updatePasswordDisplay: aPuzzle passwordHash.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/9/2007 23:22'!
nextLine

	self stepBack! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:45'!
nextRandomBlockBut: aCollection
	"Create a new random block"	

	^ BAColoredBlock randomType.

! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/19/2007 21:31'!
notifyBlockMoved

	blockMoved := true.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:29'!
raisingSpeed

	^ 0! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/9/2007 23:23'!
saveState

	| puzzle |
	puzzle := history last copy: score.
	puzzle columns: (Array new: 6).
	1 to: 6 do: [ :i |
		puzzle columns at: i put: RunArray new.
		(self column: i) blocksDo: [ :block |
			(puzzle column: i) addLast: block type]].
	history addLast: puzzle.
	! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:29'!
speedFactor

	^ 1.! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/9/2007 23:12'!
stepBack

	self loadPuzzle: history last.
	history size > 1 ifTrue: [history := history allButLast].! !

!BAPuzzlePlayground methodsFor: 'game control' stamp: 'AT 7/20/2007 00:21'!
swapRightAt: aPoint

	swapCount > 0 ifTrue: [
		self saveState.
		super swapRightAt: aPoint.
		blockMoved 
			ifTrue: [
				self swapCount: swapCount -1.
				blockMoved := false]
			ifFalse: [self stepBack]].! !

!BAPuzzlePlayground methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:34'!
initialize
	super initialize.
	
	swapCount := 0.
	history := RunArray new.
	blockMoved := false.
	self statusDisplay: 
		BAStatusDisplay createForPuzzleGame! !

!BAPuzzlePlayground methodsFor: 'accessing' stamp: 'AT 7/3/2007 00:19'!
swapCount

	^ swapCount! !

!BAPuzzlePlayground methodsFor: 'accessing' stamp: 'AT 7/3/2007 00:19'!
swapCount: anInt

	swapCount := anInt.
	self updateCountDisplay: swapCount.! !

!BAPuzzlePlayground methodsFor: 'status display' stamp: 'AT 7/16/2007 21:52'!
updateCountDisplay: anInteger

	statusDisplay updateCount: anInteger.! !

!BAPuzzlePlayground methodsFor: 'status display' stamp: 'AT 7/16/2007 09:55'!
updatePasswordDisplay: anInteger

	statusDisplay updatePassword: anInteger.! !

!BAPuzzlePlayground methodsFor: 'status display' stamp: 'AT 7/16/2007 10:15'!
updateStatusDisplay

	super updateStatusDisplay.
	self updateCountDisplay: swapCount.
! !


!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:30'!
checkGameOver
	"Simulation has no game over"! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:30'!
delayRaising: aFloat
	"No raising delay in simulation"! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/20/2007 01:12'!
fallingSpeed

	^ 3.5! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 2/21/2008 19:45'!
nextRandomBlockBut: aCollection
	"Create a new random block"	

	^ BAColoredBlock randomTypeBut: aCollection.
! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/19/2007 20:57'!
notifyBlockSweepesAt: aPoint

	"Don't notify neighbors"! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:30'!
pause
	"No pause in simulation"
! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/8/2007 17:18'!
raisingSpeed
	"Adjust speed to avoid game over or an empty playground"
	
	^ 0.5 * (1 - (self currentHeight / self maxRow))! !

!BASimulationPlayground methodsFor: 'game control' stamp: 'AT 7/3/2007 00:32'!
speedFactor

	^ 1 ! !

!BASimulationPlayground methodsFor: 'accessing' stamp: 'AT 7/19/2007 21:23'!
getValue: aSymbol
	"Provide access to variables which can be used by the step block"

	^ values at: aSymbol
! !

!BASimulationPlayground methodsFor: 'accessing' stamp: 'AT 7/3/2007 00:29'!
setValue: aSymbol to: anObject

	^ values at: aSymbol put: anObject! !

!BASimulationPlayground methodsFor: 'initialization' stamp: 'AT 7/8/2007 17:19'!
initialize
	"Initialize TAPlayGround instance"
	
	super initialize.

	self cursor visible: false.
	self statusDisplay showStatus: false.
	self setValue: #stepBlock to: [ :pg :seconds | ].

	! !

!BASimulationPlayground methodsFor: 'initialization' stamp: 'AT 7/19/2007 21:28'!
initializeInstanceVars
	
	super initializeInstanceVars.
	values := Dictionary new.
	! !

!BASimulationPlayground methodsFor: 'stepping' stamp: 'AT 7/8/2007 17:20'!
step: seconds
	"Execute the step block"
	
	super step: seconds.
	(self getValue: #stepBlock) value: self value: seconds.
	! !


!BASimulationPlayground class methodsFor: 'instance creation' stamp: 'AT 2/21/2008 19:53'!
createWith: initBlock stepBlock: stepBlock
	"create a TAPlayGround Simulation, initialize it with initBlock and let it execute stepBlock each step"

	| playground |
	playground := self createForPlayer: BADoNothingPlayer new.	
	initBlock value: playground.
	playground setValue: #stepBlock to: stepBlock.
	^ playground! !

!BASimulationPlayground class methodsFor: 'instance creation' stamp: 'NR 6/21/2007 14:47'!
default
	"Create a TAPlayGroundSimulation with default settings"
	
	^ self createWith: self initFourLines stepBlock: self stepRandomSwap! !

!BASimulationPlayground class methodsFor: 'default blocks' stamp: 'AT 6/21/2007 20:16'!
initFourLines
	"Answer a block initializing a playground with 4 new lines"

	^ [:playground |
		playground 
			setValue: #swapCounter to: 0;
			addNewLine;
			addNewLine;
			addNewLine;
			addNewLine].! !

!BASimulationPlayground class methodsFor: 'default blocks' stamp: 'AT 7/5/2007 16:05'!
stepRandomSwap
	"Answer a block letting the playground swap blocks randomly depending on seconds passed"
	
		| rnd |
		rnd := Random new.		
	^ [:pg :seconds |
		| counter |
		counter := (pg getValue: #swapCounter) + (seconds * 10).
		[counter > 1] whileTrue: [
			counter := counter -1.
			pg swapRightAt: (rnd nextInt: 5)@(rnd nextInt: pg maxRow floor)].
		pg setValue: #swapCounter to: counter]! !


!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:31'!
addDefaultField: aString

	self 
		addField: (self defaultFieldCaption: aString) 
			named: (aString,'_Caption');
		addField: self defaultField named: aString;
		addRule: self defaultRule named: aString.

! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/6/2007 10:21'!
addField: aStringMorph named: aString

	(self field: aString)
		ifNil: [self addMorph: aStringMorph]
		ifNotNil: [
			self replaceSubmorph: (self field: aString) 
				by: aStringMorph].
	fields at: aString put: aStringMorph.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:33'!
addFramesField

	self
		addSmallField: 'Frames';
		addRule: self simpleFloatRule named: 'Frames'.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/16/2007 09:51'!
addPasswordField

	self
		addSmallField: 'Password';
		addRule: self passwordRule named: 'Password'.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:33'!
addSmallField: aString

	self 
		addField: (self smallFieldCaption: aString) 
			named: (aString,'_Caption');
		addField: self smallField named: aString;
		addRule: self defaultRule named: aString.

! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:34'!
addTimeField

	self
		addSmallField: 'Time';
		addRule: self timeRule named: 'Time'.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:34'!
clear

	self removeAllMorphs.
	fields := Dictionary new.
	rules := Dictionary new.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:34'!
defaultField
	"Answer a field with default size"

	^ StringMorph
		contents: '-' 
		font: self class defaultFont
		emphasis: self class defaultEmphasis! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 6/25/2007 17:43'!
defaultFieldCaption: aString
	"Answer a field with default size"

	^ StringMorph 
		contents: aString 
		font: self class defaultFont 
		emphasis: self class defaultEmphasis! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:32'!
field: aString

	^ fields at: aString ifAbsent: [nil]! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/3/2007 22:35'!
setField: aString to: anObject

	(rules at: aString ifAbsent: [^ self])
		value: aString value: anObject.! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/6/2007 10:23'!
smallField

	^ StringMorph
			contents: '-'
			font: self class smallFont
			emphasis: self class defaultEmphasis! !

!BAStatusDisplay methodsFor: 'fields' stamp: 'AT 7/6/2007 10:23'!
smallFieldCaption: aString

	^ StringMorph
			contents: aString
			font: self class smallFont
			emphasis: self class defaultEmphasis! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/3/2007 22:36'!
addRule: aBlock named: aString

	rules at: aString put: aBlock.! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/6/2007 10:24'!
defaultRule
	"Answer a formatting rule just showing the string 
	representation of the value"

	^ [ :field :value |
		(fields at: field ifAbsent: [^ self]) 
			contents: value stringRepresentation].
	

		! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/16/2007 10:17'!
passwordRule

	^ [ :field :value |
		| symbols s |
		symbols := {' ^'. ' v'. ' <'. ' >'}.
		s := ''.
		[value > 0] whileTrue: [
			s := (symbols at: (value \\ 10)), s.	
			value := value // 10].	
		(fields at: field ifAbsent: [^ self]) 
			contents: s].! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/3/2007 22:37'!
simpleFloatRule
		"Answer a formatting rule rounding a float to 0.1"

	^ [:field :value |
			(fields at: field)
				contents: (value roundTo: 0.1) stringRepresentation]! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/6/2007 10:25'!
smallFieldRule
	"Answer a formatting rule putting the field name 
	in front of the value"
	
	^ [ :field :value |
		(fields at: field ifAbsent: [^ self]) 
			contents: (field,': ',value stringRepresentation)].! !

!BAStatusDisplay methodsFor: 'rules' stamp: 'AT 7/6/2007 10:26'!
timeRule
	"Answer a formatting rule showing a number as mm:ss"
	
	^ [ :field :seconds |
		| min sec |
		min := (seconds // 60) stringRepresentation.
		sec := (seconds floor \\ 60) stringRepresentation.
		(min size < 2) ifTrue: [min := '0',min.].		
		(sec size < 2) ifTrue: [sec := '0',sec.].
		(fields at: field) contents: (min,':',sec)]! !

!BAStatusDisplay methodsFor: 'initialization' stamp: 'AT 7/3/2007 22:35'!
initialize
	
	super initialize.
	fields := Dictionary new.
	rules := Dictionary new.
	self initializeLayout.

	! !

!BAStatusDisplay methodsFor: 'initialization' stamp: 'AT 7/6/2007 10:24'!
initializeLayout

	self
		layoutPolicy: self class defaultLayout;
		layoutInset: (self bounds expandBy: -10@-25);
		cellInset: 2;
		listDirection: #bottomToTop; 
		cellPositioning: #topLeft.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:18'!
showStatus: aBool

	self visible: aBool.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:18'!
updateBlocksWaiting: anInteger

	self setField: 'Blocks Waiting' to: anInteger.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:18'!
updateCount: anInteger

	self setField: 'Count' to: anInteger.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'ds 7/9/2007 20:23'!
updateFrames: aFloat

	self setField: 'Frames' to: aFloat.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:19'!
updateLevel: anInteger

	self setField: 'Level' to: anInteger.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/16/2007 09:54'!
updatePassword: anInteger

	self setField: 'Password' to: anInteger.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:19'!
updateScore: anInteger

	self setField: 'Score' to: anInteger.! !

!BAStatusDisplay methodsFor: 'drawing' stamp: 'AT 7/6/2007 10:18'!
updateTime: seconds
	
	self setField: 'Time' to: seconds.! !

!BAStatusDisplay methodsFor: 'stepping' stamp: 'AT 7/3/2007 22:50'!
subStep: seconds
	"Do nothing as not all submorphs are TAMorphs"! !

!BAStatusDisplay methodsFor: 'skin support' stamp: 'AT 2/21/2008 19:35'!
updateSkin
	"Dont call submorphs updateSkin as not all 
	submorphs are TAMorphs"

	self image: 
		(BlockAttack 
			imageForm: self imageName 
			fromSkin: self skin).! !


!BAStatusDisplay class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:41'!
create

	^ self withStoredForm: 'misc' , FileDirectory slash , 'status'! !

!BAStatusDisplay class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 10:28'!
createForDefaultGame

	^ (self create)
		addDefaultField: 'Score';
		addDefaultField: 'Level';
		addFramesField;
		addTimeField.! !

!BAStatusDisplay class methodsFor: 'instance creation' stamp: 'AT 7/16/2007 09:51'!
createForPuzzleGame

	^ (self create)
		addDefaultField: 'Level';
		addDefaultField: 'Count';
		addSmallField: 'Score';
		addPasswordField.! !

!BAStatusDisplay class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 10:28'!
createForVersusGame

	^ (self create)
		addDefaultField: 'Score';
		addDefaultField: 'Level';
		addSmallField: 'Blocks Waiting';
		addTimeField.! !

!BAStatusDisplay class methodsFor: 'layout' stamp: 'mo 6/18/2007 22:19'!
defaultEmphasis
	"Answer the default emphasis used by TAStatusDisplay"

	^ 0! !

!BAStatusDisplay class methodsFor: 'layout' stamp: 'mo 6/18/2007 22:19'!
defaultFont
	"Answer the default font used by TAStatusDisplay"

	^ TTCFont familyName: 'BitstreamVeraSans' pointSize: 16 emphasis: 1! !

!BAStatusDisplay class methodsFor: 'layout' stamp: 'mo 6/18/2007 22:19'!
defaultLayout
	"Answer the layout used by TAStatusDisplay"
	
	^ TableLayout new! !

!BAStatusDisplay class methodsFor: 'layout' stamp: 'mo 6/18/2007 22:16'!
smallFont
	"answer a small font used by TAStatusDisplay"

	^ TTCFont familyName: 'BitstreamVeraSans' pointSize: 11 emphasis: 1! !


!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:03'!
allDo: aBlock

	^ self subclassResponsibility ! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:43'!
isFalling
	"Answer true if all synchronized blocks are moving"

	^ self subclassResponsibility.! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:08'!
isFloating
	"Answer true if all synchronized blocks are floating"	

	^ self subclassResponsibility ! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:42'!
realIsFalling

	^ super isFalling! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:08'!
realIsFloating

	^ super isFloating! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:00'!
realRow
	
	^ super row.! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:02'!
row
	"Answer a value <<abgestimmt>> to the other blocks"
	
	^ self subclassResponsibility! !

!BASynchronizedBlock methodsFor: 'accessing' stamp: 'AT 7/20/2007 01:18'!
row: aFloat

	self fallBy: gap - (aFloat - bottomBlock row - self size)! !

!BASynchronizedBlock methodsFor: 'block control' stamp: 'AT 7/8/2007 16:53'!
realUpdateWorldPosition
	
	super updateWorldPosition.
! !

!BASynchronizedBlock methodsFor: 'block control' stamp: 'AT 7/15/2007 14:38'!
subStep: seconds
	super subStep: seconds! !

!BASynchronizedBlock methodsFor: 'block control' stamp: 'AT 7/8/2007 17:01'!
updateWorldPosition
	"Make sure all blocks update together"
	
	^ self subclassResponsibility! !


!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:06'!
allDo: aBlock

	^ self shouldNotImplement ! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:26'!
imageName

	^ imageName, self size stringRepresentation! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:09'!
isBlocked

	^ true! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:09'!
isFalling

	^ master isFalling! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:09'!
isFloating

	^ master isFloating! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 6/20/2007 08:30'!
master

	^ master! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 6/20/2007 08:23'!
master: aBlock

	master := aBlock! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 13:09'!
row
	"For better synchronization, always use the masters row"
	
	^ master row! !

!BASlaveBlock methodsFor: 'accessing' stamp: 'AT 7/2/2007 22:27'!
size

	^ master ifNil: [1] ifNotNil: [master size]! !

!BASlaveBlock methodsFor: 'initialization' stamp: 'AT 6/24/2007 17:30'!
initialize
	"Initialize TAAbstractBlock instance"
	
	super initialize.
	self activate.! !

!BASlaveBlock methodsFor: 'block control' stamp: 'AT 7/8/2007 17:08'!
notifyNeighborSweepes: aPoint

	master notifyNeighborSweepes: aPoint.! !

!BASlaveBlock methodsFor: 'block control' stamp: 'AT 7/3/2007 00:09'!
updateWorldPosition
	"Do nothing, updating will be caused by master"
! !


!BASlaveBlock class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
create

	^ BASlaveBlock withStoredForm: 'boxes' , FileDirectory slash , 'big_center'! !

!BASlaveBlock class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:40'!
createEnd

	^ BASlaveBlock withStoredForm: 'boxes' , FileDirectory slash , 'big_right'! !


!BATrashBlock methodsFor: 'accessing' stamp: 'AT 2/21/2008 19:47'!
addSlaves: anInt

	1 to: anInt-1 do: [ :i |
		self addSlave: BASlaveBlock create].
	self 
		addSlave: BASlaveBlock createEnd;
		updateSkin;
		allDo: [ :block | block fallingDelay: 0].! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 12:19'!
addSlave: aTASlaveBlock

	slaves add: aTASlaveBlock.
	aTASlaveBlock master: self.
	(self playground 
		column: (self column + slaves size)) 
			insertBlock: aTASlaveBlock atHeight: self realRow.
	aTASlaveBlock addToPlayground: self playground.
				! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 11:06'!
allDo: aBlock

	slaves do: [ :slave | aBlock value: slave].
	^ aBlock value: self! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 11:18'!
imageName

	^ imageName, self size stringRepresentation! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 6/20/2007 08:29'!
isBlocked

	^ true.! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 12:43'!
isFalling
	
	self allDo: [ :block | block realIsFalling ifFalse: [^ false]].
	^ true! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/15/2007 18:37'!
isFloating
	
	self allDo: [ :block | block realIsFloating ifFalse: [^ false]].
	^ true! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:14'!
row

	self synchronizeRows.
	^ self realRow.! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 11:06'!
size

	^ size! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/6/2007 11:06'!
size: anInt

	size := anInt.
	self updateSkin! !

!BATrashBlock methodsFor: 'accessing' stamp: 'AT 7/8/2007 17:05'!
synchronizeRows

	isSynchronized ifFalse: [
		| row |
		row := 0.
		self 
			allDo: [ :block | row := row max: block realRow];
			allDo: [ :block | block row: row].
		isSynchronized := true].! !

!BATrashBlock methodsFor: 'initialization' stamp: 'AT 7/6/2007 10:50'!
initialize
	
	super initialize.
	self activate.
	isSynchronized := false.	
	slaves := Set new.
	size := 1.! !

!BATrashBlock methodsFor: 'block control' stamp: 'AT 7/2/2007 22:36'!
notifyNeighborSweepes: aPoint
	
	self synchronizeRows.	
	size > 1 
		ifTrue: [self replaceWithSmallerTrash]
		ifFalse: [self replaceWithColoredBlocks].! !

!BATrashBlock methodsFor: 'block control' stamp: 'AT 2/21/2008 19:45'!
replaceWithColoredBlocks
	
	self allDo: [ :block |
		block replaceWith: BAColoredBlock randomType].
! !

!BATrashBlock methodsFor: 'block control' stamp: 'AT 2/21/2008 19:47'!
replaceWithSmallerTrash
	
	| trashSize playground position |
	trashSize := (slaves size+1)@1.
	playground := self playground.
	position := self gridPosition - (0@self size).
	self allDo: [ :block | block remove].
	1 to: size do: [ :i |
		BATrashBlock 
			createSize: trashSize 
			in: playground 
			at: position + (0@i)]! !

!BATrashBlock methodsFor: 'block control' stamp: 'AT 7/15/2007 15:26'!
updateWorldPosition

	self allDo: [ :block | block realUpdateWorldPosition].
	! !

!BATrashBlock methodsFor: 'stepping' stamp: 'AT 7/6/2007 11:04'!
step: seconds

	super step: seconds.
	isSynchronized := false.

	! !


!BATrashBlock class methodsFor: 'instance creation' stamp: 'rkrk 5/9/2008 16:41'!
create

	^ self withStoredForm: 'boxes' , FileDirectory slash , 'big_left'! !

!BATrashBlock class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 12:24'!
createSize: aPoint in: aTAPlayground
	"Creates one master and aPoint x -1 slave blocks on 
	top of the playground"

	| x y |
	x := (Random new) nextInt: (6 - aPoint x + 1).
	y := aTAPlayground maxRow - 
		(aTAPlayground column: x) yOffset - 0.1.
	^ self 
		createSize: aPoint 
		in: aTAPlayground
		at: x@y.! !

!BATrashBlock class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 13:01'!
createSize: aPoint in: aPlayground at: position
	"Creates one master and (size x -1) slave blocks in the
	playground at the specified position"

	| master |
	aPoint y > 2 ifTrue: [^ self notYetImplemented].
	master := self create: aPoint y.	
	(aPlayground column: position x) 
		insertBlock: master 
		atHeight: position y.
	master addToPlayground: aPlayground.		
	^ master addSlaves: aPoint x -1! !

!BATrashBlock class methodsFor: 'instance creation' stamp: 'AT 7/2/2007 22:49'!
createWidth: width inColumn: aTAColumn atHeight: height
	"Creates one master an width-1 slave blocks"
	"reluctant, this is only for bigblocks simulation"
	
	^ self
		createSize: width@1
		in: aTAColumn playground
		at: (aTAColumn index)@height! !

!BATrashBlock class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 13:03'!
create: anInt

	^ self create size: anInt! !


!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/3/2007 22:59'!
activeComponents

	^ activeComponents! !

!BlockAttack methodsFor: 'accessing' stamp: 'NR 6/19/2007 15:17'!
activeComponents: aSet
	
	activeComponents := aSet.! !

!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/3/2007 22:59'!
addPlayground: aMorph 
	
	playgrounds addFirst: aMorph.	
	self addActiveComponent: aMorph.! !

!BlockAttack methodsFor: 'accessing' stamp: 'NR 6/19/2007 15:17'!
menu

	^ menu! !

!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/6/2007 11:56'!
menu: aTAMenu
	"Add aMenu as the recievers main menu"

	menu ifNotNil: [
		self closeSubmenu;
			removeMorph: menu;
			removeActiveComponent: menu].	
	self addMorphCentered: aTAMenu.
	aTAMenu initializeKeys.
	^ menu := aTAMenu.! !

!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:01'!
playgrounds

	^ playgrounds! !

!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:12'!
playgrounds: anArray

	^ self alignPlaygrounds: anArray! !

!BlockAttack methodsFor: 'accessing' stamp: 'AT 7/3/2007 23:10'!
playground: aPlayground

	^ self playgrounds: {aPlayground}! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 7/3/2007 23:02'!
addActiveComponents: aCollection
		
	aCollection do: [:item | 
		self addActiveComponent: item].! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 7/3/2007 23:01'!
addActiveComponent: aMorph
		
	self activeComponents add: aMorph.! !

!BlockAttack methodsFor: 'event handling' stamp: 'dj 6/18/2007 17:32'!
handlesKeyboard: anEvent
	"Enables keyboard handling"
	
	^ true! !

!BlockAttack methodsFor: 'event handling' stamp: 'dj 6/18/2007 17:33'!
handlesMouseOver: anEvent
	"Enables handling of mouse over events"
	
	^ true! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 7/12/2007 16:03'!
keyDown: anEvent
	"Handle keyDown event. 
	Toggle menu when the menu key was pressed,
	dispatch all events to active components else"
	
	anEvent wasHandled: true.
	(self class isMenuKey: anEvent) ifTrue: [^ self toggleMenu].
	self activeComponents do: [ :aComponent | 
		aComponent keyEvent: anEvent]
	
	
! !

!BlockAttack methodsFor: 'event handling' stamp: 'NR 6/15/2007 18:52'!
mouseEnter: evt
	"Handle mouse over event"

	ActiveHand newKeyboardFocus: self.! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 7/3/2007 23:03'!
removeActiveComponents: aCollection
	
	aCollection do: [ :item |
		self removeActiveComponent: item].! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 7/3/2007 23:28'!
removeActiveComponent: aMorph
	
	self activeComponents remove: aMorph ifAbsent: [].! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 2/21/2008 19:36'!
setPlayer1Keys: anArray

	BlockAttack player1Keys: anArray.
	menu initializeKeys.! !

!BlockAttack methodsFor: 'event handling' stamp: 'AT 2/21/2008 19:36'!
setPlayer2Keys: anArray

	BlockAttack player2Keys: anArray.
	menu initializeKeys.! !

!BlockAttack methodsFor: 'layout' stamp: 'AT 2/21/2008 19:36'!
addPlayground: aPG showStatusIn: aMorph atTopLeft: aBool
	"Add Playground and Status Display"
	
	| yOffset bg |
	
	bg := BlockAttack backgroundPlayground.
	self addRightmost: bg.
	bg addMorphCentered: aPG.
	self addPlayground: aPG.	
	yOffset := bg height - aPG height // 2.
	aPG statusDisplay position: 
		(aBool 
			ifTrue: [0@yOffset] 
			ifFalse: [
				(aMorph width - aPG statusDisplay width) @
				(bg height - yOffset - aPG statusDisplay height)]).
	aMorph addMorphRelative: aPG statusDisplay.! !

!BlockAttack methodsFor: 'layout' stamp: 'AT 7/3/2007 23:12'!
addRightmost: aMorph

	aMorph ifNil: [^ self].
	aMorph position: width@0 + self position.
	self addMorph: aMorph behind: menu.
	bodyparts addLast: aMorph.
	width := width + aMorph width.! !

!BlockAttack methodsFor: 'layout' stamp: 'AT 2/21/2008 19:36'!
alignPlaygrounds: anArray
	
	| left status |
	"start"
	self clean.
	anArray size odd ifTrue: [
		self addRightmost: BlockAttack backgroundStatus].
	
	"add playgrounds"
	left := true.
	(anArray size) to: 1 by: -1 do: [:i |	
		left 
			ifTrue: [status := BlockAttack backgroundStatus]
			ifFalse: [self addRightmost: status].				
		self
			addPlayground: (anArray at: i)
			showStatusIn: status
			atTopLeft: left.
		left := left not].		
				
	"finish"
	left ifFalse: [self addRightmost: status].
	self finish.! !

!BlockAttack methodsFor: 'layout' stamp: 'AT 2/21/2008 19:36'!
clean

	self visible: false.
	bodyparts do: [ :morph |
		self 
			removeMorph: morph;
			removeActiveComponent: morph].
	bodyparts := RunArray new.
	playgrounds := RunArray new.	
	width := 0.
	self addRightmost: BlockAttack backgroundLeft.! !

!BlockAttack methodsFor: 'layout' stamp: 'AT 2/21/2008 19:36'!
finish

	self addRightmost: (BlockAttack backgroundRight).	
	bodyparts do: [ :morph |		
		morph "center all morphs"
			top: (morph top - (morph height - self height // 2));
			left: (morph left - (width - self width // 2))].
	menu ifNotNil: [menu moveToCenter].
	self visible: true.! !

!BlockAttack methodsFor: 'menu' stamp: 'AT 6/24/2007 23:16'!
closeMenu
	"Close menu if allowed"
	
	menu close.! !

!BlockAttack methodsFor: 'menu' stamp: 'AT 7/3/2007 23:17'!
closeSubmenu
	"Force menu to close"

	menu 
		closeSubmenu;
		hide.
	self
		removeActiveComponent: menu;
		addActiveComponents: playgrounds;
		run.! !

!BlockAttack methodsFor: 'menu' stamp: 'AT 7/3/2007 23:15'!
showMenu

	self
		pause;
		removeActiveComponents: playgrounds;
		addActiveComponent: menu.		
	menu show.! !

!BlockAttack methodsFor: 'menu' stamp: 'AT 7/3/2007 23:15'!
toggleMenu

	menu activeMenu visible
		ifTrue: [self closeMenu] 
		ifFalse: [self showMenu]! !

!BlockAttack methodsFor: 'initialization' stamp: 'AT 7/6/2007 10:37'!
initialize

	super initialize.	
	skin := self class defaultSkin.
	bodyparts := RunArray new.
	self 
		initializeComponents;
		topLeft: (Display extent - self extent // 2);		
		openInWorld;
		startStepping;
		run.! !

!BlockAttack methodsFor: 'initialization' stamp: 'AT 2/21/2008 19:52'!
initializeComponents
	
	self				
		activeComponents: Set new;
		playground: BASimulationPlayground default;
		menu: (BAMenu createMainMenu).
	menu initializeKeys.
		
! !

!BlockAttack methodsFor: 'skin support' stamp: 'NR 6/26/2007 13:42'!
loadSkin: aString

	skin := aString.
	self class 
		currentSkin: aString;
		verbose: [Transcript show: 'Loaded skin: ',aString;cr.].
	self updateSkin.! !

!BlockAttack methodsFor: 'skin support' stamp: 'AT 2/21/2008 19:36'!
skin

	^ skin ifNil: [BlockAttack defaultSkin] ifNotNil: [skin].! !

!BlockAttack methodsFor: 'skin support' stamp: 'AT 7/3/2007 23:20'!
updateSkin

	super updateSkin.
	self alignPlaygrounds: playgrounds.! !

!BlockAttack methodsFor: 'game control' stamp: 'AT 2/21/2008 19:52'!
newPuzzleGame: difficulty

	self playgrounds: {
		(BAPuzzlePlayground createForPlayer1) 
			difficulty: difficulty}.	
	(self menu: BAMenu createDefaultGameMenu)
		parentMenu: self.! !

!BlockAttack methodsFor: 'game control' stamp: 'AT 2/21/2008 19:52'!
newSinglePlayerGame: difficulty

	self playgrounds: {BADefaultPlayground createForPlayer1}.
	(self menu: BAMenu createDefaultGameMenu)
		parentMenu: self.	
	playgrounds do: [ :pg |
		pg
			difficulty: difficulty;
			addNewLine; 	addNewLine;
			addNewLine;	addNewLine; 
			addNewLine].
	! !

!BlockAttack methodsFor: 'game control' stamp: 'AT 2/21/2008 19:52'!
newVersusGame: difficulty

	self playgrounds: {
		BADefaultPlayground createForPlayer1.
		BADefaultPlayground createForPlayer2}.
	(self menu: BAMenu createDefaultGameMenu)
		parentMenu: self.	
	playgrounds do: [ :pg |
		pg
			statusDisplay: BAStatusDisplay createForVersusGame;
			difficulty: difficulty;
			addNewLine; 	addNewLine;
			addNewLine;	addNewLine; 
			addNewLine].		
! !

!BlockAttack methodsFor: 'game control' stamp: 'ds 7/9/2007 20:08'!
notifyChainSize: anInt by:  aPlayground
	"Tell all playgrounds to add trashblocks"
	
	playgrounds do: [ :pg |
		pg = aPlayground ifFalse: [
			| widht |
			width := anInt-1.
			[width > 0] whileTrue: [
				pg addTrashBlock: (width min: 6 max: 2)@2.
				width := width - 6]]].! !

!BlockAttack methodsFor: 'game control' stamp: 'NR 7/18/2007 09:47'!
notifyComboSize: anInt by:  aPlayground
	"Tell all playgrounds to add trashblocks"
	
	playgrounds do: [ :pg |
		pg  = aPlayground ifFalse: [
			| widht |
			width := anInt-1.
			[width > 0] whileTrue: [
				pg addTrashBlock: (width min: 6 max: 2)@1.
				width := width - 6]]].! !

!BlockAttack methodsFor: 'game control' stamp: 'AT 7/6/2007 10:36'!
notifyGameOver

	playgrounds do: [ :pg | pg gameOver].! !

!BlockAttack methodsFor: 'game control' stamp: 'NR 6/19/2007 20:07'!
quit

	self delete.! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 6/20/2007 13:33'!
pause

	playgrounds do: [ :pg | pg pause].! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 6/20/2007 13:33'!
run

	playgrounds do: [ :pg | pg run].! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 7/6/2007 12:16'!
startStepping

	lastStep := Time millisecondClockValue.
	^ super startStepping! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 7/6/2007 12:16'!
stepAt: millisecondClockValue
	"Calculate the passed time until last step and 
	let all submorphs step"
	
	lastStep ifNotNil: [
		self subStep: (0.001 * (millisecondClockValue - lastStep)).
		lastStep := millisecondClockValue].! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 6/24/2007 19:53'!
stepTime
	"As fast as possible"
	
	^ 0! !

!BlockAttack methodsFor: 'stepping' stamp: 'AT 6/21/2007 00:08'!
stopStepping
	
	lastStep := nil.
	^ super stopStepping! !


!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 3/10/2008 18:56'!
addDirectory: aFileDirectoryPath withPrefix: directoryPrefix toSkin: aSkin
	"Load all images in a given directory including images in subdirectories"
	
	| directory |
	directory := FileDirectory on: aFileDirectoryPath.
	
	directory directoryNames do: [:subdirectory | 
		self addDirectory: (directory relativeNameFor: subdirectory) withPrefix: (directoryPrefix,subdirectory,FileDirectory slash) toSkin: aSkin.].
	(directory fileNamesMatching: '*.png;*.jpg;*.gif;*.jpeg') do: [:imageFile | 
		self addImage: (directory relativeNameFor: imageFile) withPrefix: directoryPrefix toSkin: aSkin.].
	

	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/29/2007 18:52'!
addImage: aImagePath withPrefix: directoryPrefix toSkin: aSkin
	"Add an image with aImagePath to the dictionary of images"

	| imageName |
	imageName := directoryPrefix,(FileDirectory baseNameFor: (FileDirectory localNameFor: aImagePath)).
	
	imageDictionary at: imageName put: (self readImageFile: aImagePath). 
	aSkin add: imageName.
	self verbose: [Transcript show: '[image] ',imageName,' added'; cr.].! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/27/2007 16:06'!
deleteObsoleteSkins
	"Delete all skins which no longer exist on disk."
	
	| directory |	
	directory := FileDirectory on: self imagePath. 
	
	skins keysAndValuesDo: [:key :value |
		(directory directoryNames contains: [:dirname | dirname = key. ]) ifFalse: [
			self removeSkin: key. ]].! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/29/2007 18:51'!
imageForm: aName
	"Answer the imageForm stored in imageDB at aName, choose default skin."

	^ self imageForm: aName fromSkin: 'default'
	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 5/9/2008 16:42'!
imageForm: aName fromSkin: aSkin
	"Answer the imageForm stored in imageDB at aName"

	| imageName |
	imageDictionary ifNil: [self loadImages.]. 
	imageName := self imageIdentifier: aName in: aSkin.

	^ imageDictionary at: imageName ifAbsent:  [ 
			"self halt."
			Transcript cr; show: 'image not found: ',imageName. 
			self defaultImageForm]
	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 3/10/2008 00:12'!
imageIdentifier: aImage in: aSkin
	"Answer the image identifier from an image named aName. "

	| skin defaultIdentifier slash |
	slash := FileDirectory slash.
	defaultIdentifier := self defaultSkin, slash ,aImage.

	skin := skins at: aSkin ifAbsent: [^ defaultIdentifier]. 
	skin ifNotNil: [(skin allSatisfy: [:element | element = (aSkin , slash , aImage)]) 
			ifTrue: [^ aSkin , slash , aImage]
			ifFalse: [^ defaultIdentifier]].
	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'mk 6/20/2007 23:11'!
imagePath
	"Answer the image path"

	^ self asSqueakResource: 'images'! !

!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 5/9/2008 15:22'!
loadImages
	"Build imageDB. Therefore scan the imagePath, adding all 
	images found in it to the DB. Each image added can be 
	accessed with an imageIdentifier containing the relative 
	path from imagePath and its basicName (without extention). 
	Be sure not to place images with the same basicName into 
	the same directory under imagePath, because only one of 
	those will be recognized then. 
	
	Warning: (!!) It is unsave to do any image storage 
	operation when one or more games are running. 
	The results might be unpredictable."
	
	imageDictionary := Dictionary new.
	skins := Dictionary new.
	
	Transcript show: '[ImageDB] scanning image path'; cr.
	self loadSkins.
	Transcript show: '[ImageDB] load complete'; cr.
	
	thumbnail := self imageForm: 'thumbnail'.
! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/29/2007 18:53'!
loadSkins
	"Read skins from disk.
	
	Warning: (!!) It is unsave to do any image storage 
	operation when one or more games are running. 
	The results might be unpredictable."
	
	(FileDirectory on: self imagePath) directoryNames do: 
		[:subdirectory | 
			skins at: subdirectory put: (self readSkin: subdirectory). ].! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/29/2007 18:52'!
readImageFile: aImageName
	"Read an image from disc"

	^ ImageReadWriter formFromFileNamed: aImageName
	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 3/10/2008 18:57'!
readSkin: aName
	"Read an skin from disk"

	| skin |
	skin := Set new.
	self addDirectory: (self skinPath: aName) withPrefix: aName,FileDirectory slash toSkin: skin.
	Transcript show: '[skin] ',aName,' loaded'; cr. 
	^ skin
	! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/27/2007 16:05'!
reloadSkins
	"Reload all skins saved in the system.
	
	Warning: (!!) It is unsave to do any image storage 
	operation when one or more games are running. 
	The results might be unpredictable."
	
	self 
		deleteObsoleteSkins;
		loadSkins.
! !

!BlockAttack class methodsFor: 'image storage' stamp: 'NR 6/27/2007 15:59'!
removeSkin: aName
	"Remove a skin from the system"
	
	skins keysAndValuesRemove: [:key :value |
		key = aName.].
	imageDictionary keysAndValuesRemove: [:key :value | 
		key startsWith: aName.].
	Transcript show: '[skin] ',aName,' removed'; cr. ! !

!BlockAttack class methodsFor: 'image storage' stamp: 'rkrk 3/10/2008 18:57'!
skinPath: aName
	"Answer the skin path for a specific skin"

	^ self asSqueakResource: 'images',FileDirectory slash,aName! !

!BlockAttack class methodsFor: 'misc' stamp: 'rkrk 5/9/2008 15:24'!
asSqueakResource: aFilePath
	"Answer a path relative to squeaks home directory created out of a relative path of a project resource"

	^ (FileDirectory on: FileDirectory default pathName , FileDirectory slash , self projectPath , aFilePath) fullName
	"^ (FileDirectory uri: (self projectPath,aFilePath)) fullName"! !

!BlockAttack class methodsFor: 'misc' stamp: 'NR 7/5/2007 18:44'!
install
	"Release all resources which have been loaded from disk"
	self 
		player1Keys;
		player2Keys;
		loadImages;
		loadPuzzleLevels.
	Transcript show: '[TetrisAttack] data loaded'; cr.! !

!BlockAttack class methodsFor: 'misc' stamp: 'rkrk 3/10/2008 18:57'!
projectPath
	"Answer the project path relative to squeaks home directory."

	^ 'projects',FileDirectory slash,'BAttack',FileDirectory slash! !

!BlockAttack class methodsFor: 'misc' stamp: 'NR 7/5/2007 18:41'!
reinstall

	self 
		uninstall;
		install.! !

!BlockAttack class methodsFor: 'misc' stamp: 'NR 7/5/2007 18:43'!
uninstall
	"Release all resources which have been loaded from disk"
	
	player1Keys := nil.
	player2Keys := nil.
	puzzleLevels := nil.
	imageDictionary := nil.
	currentSkin := nil.
	skins := nil.
	Transcript show: '[TetrisAttack] reset'; cr.! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 18:58'!
backgroundLeft

	^ BAMorph withStoredForm: 'background',FileDirectory slash,'left'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 18:58'!
backgroundPlayground

	^ BAMorph withStoredForm: 'background',FileDirectory slash,'playground'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 18:58'!
backgroundRight

	^ BAMorph withStoredForm: 'background',FileDirectory slash,'right'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 18:58'!
backgroundStatus

	^ BAMorph withStoredForm: 'background',FileDirectory slash,'status'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 7/5/2007 18:46'!
currentSkin
	
	^ currentSkin ifNil: [currentSkin := self defaultSkin].! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 7/5/2007 18:48'!
currentSkin: aString

	currentSkin := aString.! !

!BlockAttack class methodsFor: 'class variables' stamp: 'AT 7/19/2007 23:00'!
defaultImageForm
	"Answer an image Form which is used as the default image form."

	^ (ScriptingSystem formAtKey: 'Painting') deepCopy! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 7/5/2007 18:48'!
defaultSkin

	^ 'default'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 00:18'!
descriptionForPartsBin

	^ self 	
			partName:		'BlockAttack'
			categories:		#('Games')
			documentation:	'Das beste Spiel ever.'
			sampleImageForm: thumbnail! !

!BlockAttack class methodsFor: 'class variables' stamp: 'AT 7/12/2007 15:36'!
isMenuKey: anEvent
	"Answer if the menu key was pressed, 
	the menu key is tab (mac: 48, else: 9)"

	| tabOnCurrentOS |
	
	((SmalltalkImage current getSystemAttribute: 1001) = 'Mac OS')  
		ifTrue: [ tabOnCurrentOS := #( 48 ) ]
		ifFalse: [ tabOnCurrentOS := #( 9 ) ].

	^ ((tabOnCurrentOS indexOf: anEvent keyValue) = 0) not.	
	"	Transcript show: anEvent keyValue.
	Transcript cr."! !

!BlockAttack class methodsFor: 'class variables' stamp: 'mp 7/9/2007 13:28'!
player1Keys
	player1Keys ifNil: [
		(player1Keys := RunArray new)
			addLast: #( 30 126 ); "<up arrow>"		
			addLast: #( 31 125 ); "<down arrow>"
			addLast: #( 28 123 ); "<left arrow>"
			addLast: #( 29 124 ); "<right arrow>"
			addLast: #( 32 49 ); "Space"
			addLast: #( 190 47 ). "."	].
	^ player1Keys! !

!BlockAttack class methodsFor: 'class variables' stamp: 'AT 7/15/2007 23:53'!
player1Keys: anArray

	player1Keys := anArray! !

!BlockAttack class methodsFor: 'class variables' stamp: 'CT 7/12/2007 12:21'!
player2Keys
	player2Keys ifNil: [
		(player2Keys _ RunArray new)
			addLast: #( 87 13 ); "W"
			addLast: #( 83 1 ); "S"
			addLast: #( 65 0 ); "A"
			addLast: #( 68 2 ); "D"
			addLast: #( 16 8 ); "C"
			addLast: #( 113 9 ). "V"	].
	^ player2Keys! !

!BlockAttack class methodsFor: 'class variables' stamp: 'AT 7/15/2007 23:53'!
player2Keys: anArray

	player2Keys := anArray! !

!BlockAttack class methodsFor: 'class variables' stamp: 'AT 6/26/2007 13:07'!
puzzleLevel: anInt
	puzzleLevels ifNil: [self loadPuzzleLevels].
	^ puzzleLevels at: anInt.! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 6/28/2007 10:51'!
skins

	^ skins! !

!BlockAttack class methodsFor: 'class variables' stamp: 'rkrk 3/10/2008 18:58'!
title
	^ BAMorph withStoredForm: 'misc',FileDirectory slash,'title'! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 6/28/2007 10:49'!
verbose
	"Answer whether verbose information is requested."
	
	^ false! !

!BlockAttack class methodsFor: 'class variables' stamp: 'NR 6/28/2007 10:49'!
verbose: aBlock
	"Evaluate block if verbose information is requesed."
	
	^ self verbose ifTrue: [aBlock value.]! !

!BlockAttack class methodsFor: 'instance creation' stamp: 'AT 6/26/2007 17:45'!
create
	"creates a new TAMain"

	^ (self new) loadSkin: self currentSkin.
	
	
	! !

!BlockAttack class methodsFor: 'instance creation' stamp: 'AT 7/6/2007 10:43'!
createWithPlayground: aPlayground

	^ (self create)
			playgrounds: {aPlayground}. 
! !

!BlockAttack class methodsFor: 'instance creation' stamp: 'AT 6/25/2007 18:02'!
newStandAlone
	^ self newGame.! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'AT 7/16/2007 21:25'!
levelByPassword: anInteger

	puzzleLevels do: [ :level | 
		(level hasPassword: anInteger) ifTrue: [^ level]].
	^ puzzleLevels at: 1.! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'AT 2/21/2008 19:45'!
loadLevelFrom: aHeader and: someContent
	"Load a level from two Strings: the first identifying the level itself and the second defining its contents. Answer the level or nil, if the data could not be parsed."

	| a b blocktypes header content columns password swapCount id |
	
	header := aHeader withBlanksCondensed.
	content := someContent withBlanksCondensed.
	
	a := header lastIndexOf: $[ ifAbsent: [^ nil]. 
	b := header lastIndexOf: $] ifAbsent: [^ nil].
	(a > b) ifTrue: [^ nil].

	header := (header copyFrom: a to: b) subStrings: ','.
	(header size = 3) ifFalse: [^ nil].
	content := (content subStrings: ';').
	(content size = 6) ifFalse: [^ nil].

	(id := (header atWrap: 1) asInteger) ifNil: [^ nil].
	(password := (header atWrap: 3) asInteger) ifNil: [^ nil].
	(swapCount := (header atWrap: 2) asInteger) ifNil: [^ nil].
	
	blocktypes := BAColoredBlock blockTypes.
	columns := Array new: 6.
	(1 to: content size) do: [:i |
		| colcontents |
		colcontents := (content atWrap: i) subStrings: ','.
		columns at: i put: RunArray new.
		(1 to: colcontents size) do: [:j |
                | int | 
                (int := (colcontents at: j) asInteger) ifNil: [^nil].
                ((int < 1) or: [int > blocktypes size]) ifFalse: [
                	(columns atWrap: i) addLast: (blocktypes atWrap: int).
			].
		].
	].

	^ (BAPuzzleLevel create: id)
		count: swapCount;
		passwordHash: password;
		columns: columns! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'NR 6/26/2007 12:47'!
loadPuzzleLevels
	"Load all puzzle levels stored on the disc and answer 
	them as a Collection. Levels have to be stored in the 
	following manner: 
		line n: 		Level [$levelid,$turns,$password] 
		line n + 1: $column1;column2;...;column6 ...	
			
	with $password beeing the hash of the original password, 
	$turns beeing the number of turns a player may swap blocks,
	$column consisting of elements $e1,$e2,...eN whereas an 
	element is an integer representing a blockType. An empty 
	column must contain a 0 to indicate that it is empty.
	Lines starting with a # are treated as commends."

	puzzleLevels := self parsePuzzleLevelData: self readPuzzleLevelData.	
	Transcript show: '[puzzle levels] ', puzzleLevels size asString, ' loaded';cr.! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'AT 7/16/2007 10:05'!
parsePuzzleLevelData: aString
	"Answer puzzle levels parsed from aString"
	
	| levels level |
	levels := RunArray new.
	(1 to: (aString lineCount / 2)) do: [:index |
		level := self loadLevelFrom: 
			(aString lineNumber: ((index * 2) - 1)) and: 
			(aString lineNumber: (index * 2)).
		
		level ifNotNil: [ 
			levels addLast: level. 
			self verbose: [
				Transcript show: '[puzzle level] ',level id asString,' loaded';cr.].
		] ifNil: [
			self verbose: [Transcript show: '[error] could not parse level';cr. ]].
	].

	^ levels

! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'NR 6/21/2007 18:55'!
puzzleLevelFilePath
	"Answer the file in which data about puzzle levels are stored"
	
	^ self asSqueakResource: 'levels.txt'

! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'rkrk 5/9/2008 15:29'!
readPuzzleLevelData
	"Answer the entire contents of the level data file as a string. Whitespace has been removed from it, except for crs."
	
	| text s stream |
	
	text := ''.
	stream := FileStream readOnlyFileNamed: self puzzleLevelFilePath.
	[[stream atEnd] whileFalse: [
		((s := stream next asString) = String cr) 
			ifFalse: [text := text, s withBlanksTrimmed.]
			ifTrue: [ text := text,s.]]
	] ensure: [stream close].
			
	^ self withCommentsRemoved: text

! !

!BlockAttack class methodsFor: 'puzzle levels' stamp: 'AT 6/26/2007 15:14'!
withCommentsRemoved: aString
	"Answer the argument without lines beginning with a #."
	
	| extracted |
	
	extracted := ''.
	aString linesDo: [:line |
		(line beginsWith: '#') ifFalse: [ 
			extracted := extracted,line,String cr]].
	
	^ extracted

! !

!BlockAttack class methodsFor: 'new game' stamp: 'AT 2/21/2008 19:52'!
newGame
	"Create a new Game"
	
	^ (self createWithPlayground: 
	BASimulationPlayground default) showMenu.
! !

!BlockAttack class methodsFor: 'new game' stamp: 'AT 2/21/2008 19:52'!
simulationBigBlocks
	"Show a simulation of the game with 2 BigBlocks"
	
	| initBlock stepBlock game |
	
	initBlock := [ :playground |
		BASimulationPlayground initFourLines value: playground.
		BATrashBlock createWidth: 3 inColumn: (playground column: 1) atHeight: 5.
		BATrashBlock createWidth: 3 inColumn: (playground column: 4) atHeight: 5.	
		1 to: 3 do: [ :i |
		playground columns do: [ :column |
			"self halt."			
			| block |
			block := BAColoredBlock randomType.			
			column insertAtTop: block.
			block addToPlayground: playground]]].

	stepBlock := BASimulationPlayground stepRandomSwap.		
	
	game := self createWithPlayground: 
		(BASimulationPlayground 
			createWith: initBlock 
			stepBlock: stepBlock).
	
	^game! !

